000100 PROCESS DYNAM NUMPROC(PFD) TRUNC(OPT) APOST LIB NOSEQ RES RENT           
000200* LAST UPDATE ON 14 Aug 1995 AT 08:53:50 BY  VEND789 VERSION 01   *       
000300 ID DIVISION.                                                             
000400 PROGRAM-ID. ACIFOTX.                                                     
000500 AUTHOR. TURETZKY--HYDRA.                                                 
000600 INSTALLATION. IBM BOULDER PROGRAMMING CENTER.                            
000700                                                                          
000800               NOTE: REQUIRES VS COBOL II.  This program is a             
000900               sample exit for ACIF (APKACIF,5648-062)                    
001000               demonstrating the use of the ACIF output exit in           
001100               a simple print archive.                                    
001200                                                                          
001300               In order to use this exit, include the control             
001400               OUTEXIT=ACIFOTX to enable this exit, and include           
001500               the load module in a dataset referenced in STEPLIB         
001600               or elsewhere in the module search order.                   
001700                                                                          
001800               The program will delete the indexing NOP inserted          
001900               by the input exit, ACIFINX, then write the                 
002000               remaining records to a VSAM RRDS. The ACIF OUTPUT          
002100               file may be dummy if it is not to be printed.              
002200                                                                          
002300               Method of operation: each output record is examined        
002400               for a NOP containing the index tag string. For NOP         
002500               record, the delete code (x'01') will be returned           
002600               to ACIF. All other records are written, in                 
002700               sequence, to the RRDS. The records will then be            
002800               passed to ACIF (use code x'00') so that the index          
002900               will reflect the correct record and byte offsets.          
003000                                                                          
003100               This program must either be compiled with the              
003200               NORENT option or linked with IGZOPT with the               
003300               RTEREUS option.  (See VS COBOL II Application              
003400               Programming Guide, SC26-4045).                             
003500                                                                          
003600 DATE-WRITTEN. 18 OCT 93.                                                 
003700 DATE-COMPILED.                                                           
003800 SECURITY. IBM SAMPLE CODE ONLY.                                          
003900*/**************************************************************/         
004000*/*   (C) COPYRIGHT IBM CORPORATION, 1993                      */         
004100*/*                                                            */         
004200*/*        >>>>>>>  IMPORTANT NOTICE   <<<<<<<<<<<             */         
004300*/*                                                            */         
004400*/*   THIS PROGRAM IS NOT SUPPORTED IN ANY WAY BY IBM.  IT     */         
004500*/*   HAS NOT BEEN SUBJECTED TO ANY FORMAL IBM TESTING AND     */         
004600*/*   IS DISTRIBUTED ON AN "AS-IS" BASIS WITHOUT ANY           */         
004700*/*   WARRANTY EITHER EXPRESSED OR IMPLIED.  THE USE OF        */         
004800*/*   THIS CODE OR ANY INFORMATION OR TECHNIQUES IMPLICIT      */         
004900*/*   WITHIN IT IS THE SOLE RESPONSIBILITY OF THE CUSTOMER.    */         
005000*/*   SUCH USE DEPENDS UPON THE CUSTOMER'S ABILITY TO          */         
005100*/*   EVALUATE THE INFORMATION IN THE CONTEXT OF THEIR OWN     */         
005200*/*   PARTICULAR OPERATING ENVIRONMENT.  THIS CODE HAS         */         
005300*/*   OPERATED SUCCESSFULLY IN THE COMPUTING ENVIRONMENT AT    */         
005400*/*   THE BOULDER PROGRAMMING CENTER.  THERE IS NO             */         
005500*/*   GUARANTEE THAT IT WILL OPERATE CORRECTLY ELSEWHERE.      */         
005600*/**************************************************************/         
005700 TITLE 'ACIF Sample output Exit'.                                         
005800 ENVIRONMENT DIVISION.                                                    
005900 CONFIGURATION SECTION.                                                   
006000 SOURCE-COMPUTER. IBM-370.                                                
006100 OBJECT-COMPUTER. IBM-370.                                                
006200 INPUT-OUTPUT SECTION.                                                    
006300 FILE-CONTROL.                                                            
006400     SELECT AFPPAGOT-FILE        ASSIGN TO AFPPAGOT,                      
006500                                 ORGANIZATION RELATIVE,                   
006600                                 ACCESS MODE SEQUENTIAL,                  
006700                                 FILE STATUS AFPPAGOT-STATUS              
006800                                             VSAM-STATUS,                 
006900                                 RELATIVE KEY AFPPAGOT-REC.               
007000     EJECT                                                                
007100 DATA DIVISION.                                                           
007200 FILE SECTION.                                                            
007300 FD  AFPPAGOT-FILE,                                                       
007400     RECORD VARYING DEPENDING ON AFPPAGOT-LENGTH.                         
007500     COPY AFPAGOT                                                         
007600          REPLACING ==:PREFIX:== BY ==AFPPAGOT==.                         
007700 WORKING-STORAGE SECTION.                                                 
007800 77  PGMNAME                 PIC X(8) VALUE 'ACIFOTX'.                    
007900 77  ABND-PGM                PIC X(8) VALUE 'ILBOABN0'.                   
008000 77  ABEND-CODE              PIC 9(4) BINARY VALUE 12.                    
008100 77  PAGE-COUNT              PIC S9(8) BINARY VALUE ZERO.                 
008200 77  LINE-COUNT              PIC S9(8) BINARY VALUE ZERO.                 
008300 77  AFPPAGOT-STATUS         PIC 99.                                      
008400     88  AFPPAGOT-OK         VALUE 00.                                    
008500 77  AFPPAGOT-EOF-FLAG       PIC X    VALUE LOW-VALUE.                    
008600     88  AFPPAGOT-EOF        VALUE HIGH-VALUE.                            
008700 77  AFPPAGOT-ERROR-FLAG     PIC X    VALUE LOW-VALUE.                    
008800     88  AFPPAGOT-ERROR      VALUE HIGH-VALUE.                            
008900     SKIP2                                                                
009000 01  AFPPAGOT-LENGTH         PIC 9(8) BINARY.                             
009100     SKIP2                                                                
009200     SKIP1                                                                
009300 01  VSAM-STATUS.                                                         
009400     05  VSAM-RC                 PIC 9(4) COMP.                           
009500     05  VSAM-FCT-CODE           PIC 9(1) COMP.                           
009600     05  VSAM-FDBK-CODE          PIC 9(3) COMP.                           
009700     SKIP1                                                                
009800 01  DATE-DATA.                                                           
009900   05  RUN-DATE.                                                          
010000     10 RUN-YY                 PIC 99.                                    
010100     10 RUN-MM                 PIC 99.                                    
010200     10 RUN-DD                 PIC 99.                                    
010300   05  COMPILE-DATE.                                                      
010400     10  COMP-DATE             PIC X(8).                                  
010500     10  COMP-TIME             PIC X(12).                                 
010600   05  RUN-TIME.                                                          
010700     10  RUN-HH                PIC 99.                                    
010800     10  RUN-MM                PIC 99.                                    
010900     10  RUN-SS                PIC 99.                                    
011000     10  RUN-MS                PIC 99.                                    
011100     SKIP2                                                                
011200* THIS IS THE DATA PORTION OF THE NOP RECORD. IT SPECIFIES                
011300* THE NAME OF DIVISION AND STORE FOR INDEXING.                            
011400 01  NOP-DATA.                                                            
011500     05  NOP-EYEBALL         PIC X(11) VALUE '**INDEX**: '.               
011600     05  NOP-DIVISION-CODE   PIC 99.                                      
011700     05  NOP-DIVISION-NAME   PIC X(12).                                   
011800     05  FILLER              PIC X  VALUE SPACE.                          
011900     05  NOP-STORE-CODE      PIC 99.                                      
012000     05  NOP-STORE-NAME      PIC X(12).                                   
012100     SKIP2                                                                
012200 01  BINARY-NUMBERS.                                                      
012300     05  BIN-4                   PIC 9(8) BINARY VALUE ZERO.              
012400     05  BIN4-X                  REDEFINES BIN-4                          
012500                                 PIC X(4).                                
012600     05  BIN2                    PIC 9(4) BINARY VALUE ZERO.              
012700     05  BIN2-X                  REDEFINES BIN2.                          
012800         10  FILLER              PIC X.                                   
012900         10  BIN2-2              PIC X.                                   
013000         EJECT                                                            
013100/ AFP STRUCTURED FIELD DEFINITIONS.                                       
013200     COPY STRFLDS SUPPRESS.                                               
013300/ PASSED PARAMETERS.                                                      
013400 LINKAGE SECTION.                                                         
013500 01  OUT-PARMS.                                                           
013600     05  OUT-WORKA           POINTER.                                     
013700     05  OUT-PFATTR          POINTER.                                     
013800     05  OUT-RECPTR          POINTER.                                     
013900     05  OUT-RECLEN          PIC 9(4) BINARY.                             
014000     05  OUT-REQUEST         PIC X.                                       
014100         88  OUT-USE         VALUE X'00'.                                 
014200         88  OUT-DELETE      VALUE X'01'.                                 
014300     05  OUT-EOF-FLAG        PIC X.                                       
014400         88  OUT-EOF         VALUE 'Y'.                                   
014500         88  OUT-NOTEOF      VALUE 'N'.                                   
014600                                                                          
014700 01  OUT-UAREA.                                                           
014800     05  AFPPAGOT-REC        PIC 9(8) BINARY.                             
014900     05  OUT-FIRST-FLAG      PIC X.                                       
015000         88  OUT-FIRST       VALUE LOW-VALUE.                             
015100         88  OUT-NOTFIRST    VALUE HIGH-VALUE.                            
015200                                                                          
015300 01  OUT-ATTR.                                                            
015400     05  OUT-CC              PIC XXX.                                     
015500     05  OUT-CCTYPE          PIC X.                                       
015600         88  OUT-ANSI-CC     VALUE 'A'.                                   
015700         88  OUT-MACH-CC     VALUE 'M'.                                   
015800     05  OUT-CHARS           PIC X(20).                                   
015900     05  OUT-FORMDEF         PIC X(8).                                    
016000     05  OUT-PAGEDEF         PIC X(8).                                    
016100     05  OUT-PRMODE          PIC X(8).                                    
016200     05  OUT-TRC             PIC XXX.                                     
016300                                                                          
016400* This is a template for the output record, pointed to by                 
016500* OUT-RECPTR. The record's actual length is given by                      
016600* OUT-RECLEN.                                                             
016700 01  OUT-LINE.                                                            
016800     05  OUT-CCVAL           PIC X.                                       
016900     05  OUT-SFINTRO.                                                     
017000         10  OUT-SFLEN       PIC 9(4) BINARY.                             
017100         10  OUT-SFTYPE      PIC XXX.                                     
017200         10  OUT-SFFLAG      PIC X.                                       
017300         10  OUT-SFSEQ       PIC 9(4) BINARY.                             
017400     05  OUT-SFDATA          PIC X(32751).                                
017500 TITLE 'Initialization and Main Line'.                                    
017600 PROCEDURE DIVISION USING OUT-PARMS.                                      
017700* make work area, attributes, and output line addressable.                
017800     SET ADDRESS OF OUT-UAREA TO OUT-WORKA.                               
017900     SET ADDRESS OF OUT-ATTR TO OUT-PFATTR.                               
018000     SET ADDRESS OF OUT-LINE TO OUT-RECPTR.                               
018100* no special action is necessary at EOF.                                  
018200     IF OUT-EOF                                                           
018300      THEN                                                                
018400       DISPLAY PGMNAME, ' EOF REACHED.';                                  
018500       GOBACK;                                                            
018600     END-IF.                                                              
018700     IF OUT-FIRST                                                         
018800      THEN                                                                
018900       SET OUT-NOTFIRST TO TRUE;                                          
019000       MOVE WHEN-COMPILED TO COMPILE-DATE;                                
019100       ACCEPT RUN-DATE FROM DATE;                                         
019200       ACCEPT RUN-TIME FROM TIME;                                         
019300       OPEN OUTPUT AFPPAGOT-FILE;                                         
019400        SKIP2                                                             
019500       IF NOT AFPPAGOT-OK THEN                                            
019600          DISPLAY 'AFPPAGOT  STATUS AFTER OPEN ' AFPPAGOT-STATUS;         
019700          DISPLAY ' ';                                                    
019800          MOVE AFPPAGOT-STATUS TO RETURN-CODE;                            
019900          GOBACK;                                                         
020000       END-IF;                                                            
020100       MOVE ZERO TO AFPPAGOT-REC;                                         
020200        SKIP2                                                             
020300     END-IF.                                                              
020400     SET OUT-USE TO TRUE.                                                 
020500     EVALUATE OUT-SFTYPE;                                                 
020600      WHEN SF-NOP                                                         
020700* If this is the index NOP record, then flag it for deletion.             
020800* All other NOPs are written to the output file.                          
020900       IF OUT-SFDATA (1 : LENGTH OF NOP-EYEBALL) = NOP-EYEBALL            
021000        THEN                                                              
021100         SET OUT-DELETE TO TRUE;                                          
021200        ELSE                                                              
021300         PERFORM 0100-WRITE-PAGEOUT;                                      
021400       END-IF;                                                            
021500      WHEN SF-BPG                                                         
021600       ADD 1 TO PAGE-COUNT;                                               
021700       MOVE 0 TO LINE-COUNT;                                              
021800       PERFORM 0100-WRITE-PAGEOUT;                                        
021900      WHEN OTHER                                                          
022000       ADD 1 TO LINE-COUNT;                                               
022100       MOVE LINE-COUNT TO OUT-SFSEQ;                                      
022200       PERFORM 0100-WRITE-PAGEOUT;                                        
022300     END-EVALUATE.                                                        
022400     SKIP1                                                                
022500     GOBACK.                                                              
022600        SKIP2                                                             
022700 0100-WRITE-PAGEOUT.                                                      
022800     ADD 1 TO AFPPAGOT-REC.                                               
022900     MOVE OUT-RECLEN TO AFPPAGOT-LENGTH.                                  
023000     WRITE AFPPAGOT-RECORD FROM OUT-LINE                                  
023100       INVALID KEY                                                        
023200        DISPLAY PGMNAME, ' VSAM RELATIVE INVALID KEY.'                    
023300                ' FILE STATUS ',                                          
023400                AFPPAGOT-STATUS, ' VSAM CODES : ',                        
023500                VSAM-RC, VSAM-FCT-CODE, VSAM-FDBK-CODE;                   
023600                MOVE VSAM-RC TO RETURN-CODE;                              
023700     END-WRITE.                                                           
