000100 PROCESS DYNAM NUMPROC(PFD) TRUNC(OPT) APOST LIB NOSEQ RES RENT   APKOUTXT
000200* LAST UPDATE ON 20 Oct 1993 AT 09:35:06 BY  VEND789 VERSION 01 * APKOUTXT
000300 ID DIVISION.                                                     APKOUTXT
000400 PROGRAM-ID. APKOUTXT.                                            APKOUTXT
000500 AUTHOR. TURETZKY--HYDRA.                                         APKOUTXT
000600 INSTALLATION. IBM BOULDER PROGRAMMING CENTER.                    APKOUTXT
000700                                                                  APKOUTXT
000800               NOTE: REQUIRES VS COBOL II.  This program is a     APKOUTXT
000900               sample exit for ACIF (APKACIF,5648-062)            APKOUTXT
001000               demonstrating the use of the ACIF output exit.     APKOUTXT
001100                                                                  APKOUTXT
001200               In order to use this exit, include the control     APKOUTXT
001300               OUTEXIT=APKOUTXT to enable this exit, and include  APKOUTXT
001400               the load module in a dataset referenced in         APKOUTXT
001500               STEPLIB or elsewhere in the module search order.   APKOUTXT
001600                                                                  APKOUTXT
001700               The program will delete the Begin Document and     APKOUTXT
001800               End Document structured fields (BDT/EDT), and      APKOUTXT
001900               will insert a comment triplet on each Begin Page   APKOUTXT
002000               (BPG) structured field (I didn't say it would do   APKOUTXT
002100               anything useful).  It will also renumber each      APKOUTXT
002200               structured field sequence field within a page. If  APKOUTXT
002300               the BPG record does not contain a Page Name        APKOUTXT
002400               triplet (FQN type x'01'), one will be inserted     APKOUTXT
002410               with a sequential page number.                     APKOUTXT
002500                                                                  APKOUTXT
002600               Method of operation: each output record is         APKOUTXT
002700               examined for a BPG, BDT, or EDT structured field.  APKOUTXT
002800               If it is a BDT/EDT, the delete code (x'01') will   APKOUTXT
002900               be returned to ACIF. If it is a BPG, it will be    APKOUTXT
003000               scanned for an X'02' FQN triplet of type X'01'.    APKOUTXT
003100               If none is found, one will be inserted with the    APKOUTXT
003110               running page count.                                APKOUTXT
003200                                                                  APKOUTXT
003300               This program must either be compiled with the      APKOUTXT
003400               NORENT option or linked with IGZOPT with the       APKOUTXT
003500               RTEREUS option.  (See VS COBOL II Application      APKOUTXT
003600               Programming Guide, SC26-4045).                     APKOUTXT
003700                                                                  APKOUTXT
003800 DATE-WRITTEN. 18 OCT 93.                                         APKOUTXT
003900 DATE-COMPILED.                                                   APKOUTXT
004000 SECURITY. IBM SAMPLE CODE ONLY.                                  APKOUTXT
004100*/**************************************************************/ APKOUTXT
004200*/*   (C) COPYRIGHT IBM CORPORATION, 1993                      */ APKOUTXT
004300*/*                                                            */ APKOUTXT
004400*/*        >>>>>>>  IMPORTANT NOTICE   <<<<<<<<<<<             */ APKOUTXT
004500*/*                                                            */ APKOUTXT
004600*/*   THIS PROGRAM IS NOT SUPPORTED IN ANY WAY BY IBM.  IT     */ APKOUTXT
004700*/*   HAS NOT BEEN SUBJECTED TO ANY FORMAL IBM TESTING AND     */ APKOUTXT
004800*/*   IS DISTRIBUTED ON AN "AS-IS" BASIS WITHOUT ANY           */ APKOUTXT
004900*/*   WARRANTY EITHER EXPRESSED OR IMPLIED.  THE USE OF        */ APKOUTXT
005000*/*   THIS CODE OR ANY INFORMATION OR TECHNIQUES IMPLICIT      */ APKOUTXT
005100*/*   WITHIN IT IS THE SOLE RESPONSIBILITY OF THE CUSTOMER.    */ APKOUTXT
005200*/*   SUCH USE DEPENDS UPON THE CUSTOMER'S ABILITY TO          */ APKOUTXT
005300*/*   EVALUATE THE INFORMATION IN THE CONTEXT OF THEIR OWN     */ APKOUTXT
005400*/*   PARTICULAR OPERATING ENVIRONMENT.  THIS CODE HAS         */ APKOUTXT
005500*/*   OPERATED SUCCESSFULLY IN THE COMPUTING ENVIRONMENT AT    */ APKOUTXT
005600*/*   THE BOULDER PROGRAMMING CENTER.  THERE IS NO             */ APKOUTXT
005700*/*   GUARANTEE THAT IT WILL OPERATE CORRECTLY ELSEWHERE.      */ APKOUTXT
005800*/**************************************************************/ APKOUTXT
005900 TITLE 'ACIF Sample output Exit'.                                 APKOUTXT
006000 ENVIRONMENT DIVISION.                                            APKOUTXT
006100 CONFIGURATION SECTION.                                           APKOUTXT
006200 SOURCE-COMPUTER. IBM-370.                                        APKOUTXT
006300 OBJECT-COMPUTER. IBM-370.                                        APKOUTXT
006400     EJECT                                                        APKOUTXT
006500 DATA DIVISION.                                                   APKOUTXT
006600 WORKING-STORAGE SECTION.                                         APKOUTXT
006700 77  PGMNAME                 PIC X(8) VALUE 'APKOUTXT'.           APKOUTXT
006800 77  ABND-PGM                PIC X(8) VALUE 'ILBOABN0'.           APKOUTXT
006900 77  ABEND-CODE              PIC 9(4) BINARY VALUE 12.            APKOUTXT
007000 77  LINE-COUNT              PIC S9(8) BINARY VALUE ZERO.         APKOUTXT
007100 77  PAGE-COUNT              PIC S9(8) BINARY VALUE ZERO.         APKOUTXT
007200 77  INSERT-PHRASE           PIC X(13) VALUE 'MODIFIED BY:'.      APKOUTXT
007300 77  FQN-FOUND-FLAG          PIC X.                               APKOUTXT
007400     88  FQN-FOUND           VALUE HIGH-VALUE.                    APKOUTXT
007500     88  FQN-NOTFOUND        VALUE  LOW-VALUE.                    APKOUTXT
007600     SKIP2                                                        APKOUTXT
007700 01  DATE-DATA.                                                   APKOUTXT
007800   05  RUN-DATE.                                                  APKOUTXT
007900     10 RUN-YY                 PIC 99.                            APKOUTXT
008000     10 RUN-MM                 PIC 99.                            APKOUTXT
008100     10 RUN-DD                 PIC 99.                            APKOUTXT
008200   05  COMPILE-DATE.                                              APKOUTXT
008300     10  COMP-DATE             PIC X(8).                          APKOUTXT
008400     10  COMP-TIME             PIC X(12).                         APKOUTXT
008500   05  RUN-TIME.                                                  APKOUTXT
008600     10  RUN-HH                PIC 99.                            APKOUTXT
008700     10  RUN-MM                PIC 99.                            APKOUTXT
008800     10  RUN-SS                PIC 99.                            APKOUTXT
008900     10  RUN-MS                PIC 99.                            APKOUTXT
009000     SKIP2                                                        APKOUTXT
009100 01  BINARY-NUMBERS.                                              APKOUTXT
009200     05  BIN-4                   PIC 9(8) BINARY VALUE ZERO.      APKOUTXT
009300     05  BIN4-X                  REDEFINES BIN-4                  APKOUTXT
009400                                 PIC X(4).                        APKOUTXT
009500     05  BIN2                    PIC 9(4) BINARY VALUE ZERO.      APKOUTXT
009600     05  BIN2-X                  REDEFINES BIN2.                  APKOUTXT
009700         10  FILLER              PIC X.                           APKOUTXT
009800         10  BIN2-2              PIC X.                           APKOUTXT
009900     SKIP2                                                        APKOUTXT
010000 01  FQN-TRIPLET.                                                 APKOUTXT
010100     05  FQN-LEN             PIC X.                               APKOUTXT
010200     05  FQN-IDENT           PIC X.                               APKOUTXT
010300     05  FQN-TYPE            PIC X.                               APKOUTXT
010400     05  FQN-PAGENUM         PIC ZZ,ZZZ,ZZ9.                      APKOUTXT
010500     SKIP2                                                        APKOUTXT
010600 01  COMMENT-TRIPLET.                                             APKOUTXT
010700     05  COMMENT-LEN         PIC X.                               APKOUTXT
010800     05  COMMENT-TYPE        PIC X.                               APKOUTXT
010900     05  COMMENT-DATA        PIC X(250).                          APKOUTXT
011000     SKIP2                                                        APKOUTXT
011100 01  TRIPLET-DATA.                                                APKOUTXT
011200     05  TRIPLET-PTR             PIC 9(8) BINARY.                 APKOUTXT
011300     05  TRIPLET-LENGTH          PIC 9(4) BINARY.                 APKOUTXT
011400* offset to start of attribute value                              APKOUTXT
011500     05  ATTVAL-OFFSET           PIC 9(8) BINARY VALUE 4.         APKOUTXT
011600     SKIP2                                                        APKOUTXT
011700         EJECT                                                    APKOUTXT
011800/ AFP STRUCTURED FIELD DEFINITIONS.                               APKOUTXT
011900     COPY STRFLDS SUPPRESS.                                       APKOUTXT
012000/ PASSED PARAMETERS.                                              APKOUTXT
012100 LINKAGE SECTION.                                                 APKOUTXT
012200 01  OUT-PARMS.                                                   APKOUTXT
012300     05  OUT-WORKA           POINTER.                             APKOUTXT
012400     05  OUT-PFATTR          POINTER.                             APKOUTXT
012500     05  OUT-RECPTR          POINTER.                             APKOUTXT
012600     05  OUT-RECLEN          PIC 9(4) BINARY.                     APKOUTXT
012700     05  OUT-REQUEST         PIC X.                               APKOUTXT
012800         88  OUT-USE         VALUE X'00'.                         APKOUTXT
012900         88  OUT-DELETE      VALUE X'01'.                         APKOUTXT
013000     05  OUT-EOF-FLAG        PIC X.                               APKOUTXT
013100         88  OUT-EOF         VALUE 'Y'.                           APKOUTXT
013200         88  OUT-NOTEOF      VALUE 'N'.                           APKOUTXT
013300                                                                  APKOUTXT
013400 01  OUT-UAREA.                                                   APKOUTXT
013500     05  OUT-FIRST-FLAG      PIC X.                               APKOUTXT
013600         88  OUT-FIRST       VALUE LOW-VALUE.                     APKOUTXT
013700         88  OUT-NOTFIRST    VALUE HIGH-VALUE.                    APKOUTXT
013800                                                                  APKOUTXT
013900 01  OUT-ATTR.                                                    APKOUTXT
014000     05  OUT-CC              PIC XXX.                             APKOUTXT
014100     05  OUT-CCTYPE          PIC X.                               APKOUTXT
014200         88  OUT-ANSI-CC     VALUE 'A'.                           APKOUTXT
014300         88  OUT-MACH-CC     VALUE 'M'.                           APKOUTXT
014400     05  OUT-CHARS           PIC X(20).                           APKOUTXT
014500     05  OUT-FORMDEF         PIC X(8).                            APKOUTXT
014600     05  OUT-PAGEDEF         PIC X(8).                            APKOUTXT
014700     05  OUT-PRMODE          PIC X(8).                            APKOUTXT
014800     05  OUT-TRC             PIC XXX.                             APKOUTXT
014900                                                                  APKOUTXT
015000* This is a template for the output record, pointed to by         APKOUTXT
015100* OUT-RECPTR. The record's actual length is given by              APKOUTXT
015200* OUT-RECLEN.                                                     APKOUTXT
015300 01  OUT-LINE.                                                    APKOUTXT
015400     05  OUT-CCVAL           PIC X.                               APKOUTXT
015500     05  OUT-SFINTRO.                                             APKOUTXT
015600         10  OUT-SFLEN       PIC 9(4) BINARY.                     APKOUTXT
015700         10  OUT-SFTYPE      PIC XXX.                             APKOUTXT
015800         10  OUT-SFFLAG      PIC X.                               APKOUTXT
015900         10  OUT-SFSEQ       PIC 9(4) BINARY.                     APKOUTXT
016000     05  OUT-SFDATA          PIC X(32751).                        APKOUTXT
016100 TITLE 'Initialization and Main Line'.                            APKOUTXT
016200 PROCEDURE DIVISION USING OUT-PARMS.                              APKOUTXT
016300* make work area, attributes, and output line addressable.        APKOUTXT
016400     SET ADDRESS OF OUT-UAREA TO OUT-WORKA.                       APKOUTXT
016500     SET ADDRESS OF OUT-ATTR TO OUT-PFATTR.                       APKOUTXT
016600     SET ADDRESS OF OUT-LINE TO OUT-RECPTR.                       APKOUTXT
016700* no special action is necessary at EOF.                          APKOUTXT
016800     IF OUT-EOF                                                   APKOUTXT
016900      THEN                                                        APKOUTXT
017000       DISPLAY PGMNAME, ' EOF REACHED.';                          APKOUTXT
017100       GOBACK;                                                    APKOUTXT
017200     END-IF.                                                      APKOUTXT
017300     IF OUT-FIRST                                                 APKOUTXT
017400      THEN                                                        APKOUTXT
017500       SET OUT-NOTFIRST TO TRUE;                                  APKOUTXT
017600       MOVE WHEN-COMPILED TO COMPILE-DATE;                        APKOUTXT
017700       ACCEPT RUN-DATE FROM DATE;                                 APKOUTXT
017800       ACCEPT RUN-TIME FROM TIME;                                 APKOUTXT
017900     END-IF.                                                      APKOUTXT
018000     SET OUT-USE TO TRUE.                                         APKOUTXT
018100     EVALUATE OUT-SFTYPE;                                         APKOUTXT
018200      WHEN SF-BDT                                                 APKOUTXT
018300       SET OUT-DELETE TO TRUE;                                    APKOUTXT
018400      WHEN SF-EDT                                                 APKOUTXT
018500       SET OUT-DELETE TO TRUE;                                    APKOUTXT
018600      WHEN SF-BPG                                                 APKOUTXT
018700       ADD 1 TO PAGE-COUNT;                                       APKOUTXT
018800       MOVE 0 TO LINE-COUNT;                                      APKOUTXT
018900       PERFORM 0200-FIX-BPG;                                      APKOUTXT
019000      WHEN OTHER                                                  APKOUTXT
019100       ADD 1 TO LINE-COUNT;                                       APKOUTXT
019200       MOVE LINE-COUNT TO OUT-SFSEQ;                              APKOUTXT
019300     END-EVALUATE.                                                APKOUTXT
019400     SKIP1                                                        APKOUTXT
019500     GOBACK.                                                      APKOUTXT
019600        SKIP2                                                     APKOUTXT
019700     EJECT                                                        APKOUTXT
019800 0200-FIX-BPG.                                                    APKOUTXT
019900* First, scan the BPG for an FQN GID triplet. If one is not found,APKOUTXT
020000* insert one containing the formatted page count.                 APKOUTXT
020100* Then, locate the end of the record and insert a comment triplet APKOUTXT
020200* indicating we modified the document with a time/date stamp.     APKOUTXT
020300* Triplets begin after the token name.                            APKOUTXT
020400     MOVE 9 TO TRIPLET-PTR.                                       APKOUTXT
020500     SET FQN-NOTFOUND TO TRUE;                                    APKOUTXT
020600     PERFORM UNTIL TRIPLET-PTR >=                                 APKOUTXT
020700                   (OUT-SFLEN - LENGTH OF OUT-SFINTRO);           APKOUTXT
020800* the triplet length is the first byte of the triplet             APKOUTXT
020900       MOVE OUT-SFDATA (TRIPLET-PTR : 1) TO BIN2-2;               APKOUTXT
021000       MOVE BIN2 TO TRIPLET-LENGTH;                               APKOUTXT
021100* the triplet type is the second byte of the triplet              APKOUTXT
021200       EVALUATE (OUT-SFDATA (TRIPLET-PTR + 1 : 1));               APKOUTXT
021300        WHEN TR-FQN (2 : 1)                                       APKOUTXT
021400* the FQN type is the third byte of an FQN triplet                APKOUTXT
021500         EVALUATE (OUT-SFDATA (TRIPLET-PTR + 2 : 1));             APKOUTXT
021600          WHEN FQN-GID                                            APKOUTXT
021700           SET FQN-FOUND TO TRUE;                                 APKOUTXT
021800          WHEN OTHER                                              APKOUTXT
021900           CONTINUE;                                              APKOUTXT
022000         END-EVALUATE;                                            APKOUTXT
022100         WHEN OTHER                                               APKOUTXT
022200          CONTINUE;                                               APKOUTXT
022300       END-EVALUATE;                                              APKOUTXT
022400       ADD TRIPLET-LENGTH TO TRIPLET-PTR;                         APKOUTXT
022500     END-PERFORM.                                                 APKOUTXT
022600     IF FQN-NOTFOUND                                              APKOUTXT
022700      THEN                                                        APKOUTXT
022800       PERFORM 0300-CREATE-FQN;                                   APKOUTXT
022900     END-IF.                                                      APKOUTXT
023000     PERFORM 0400-CREATE-COMMENT.                                 APKOUTXT
023100     SKIP2                                                        APKOUTXT
023200 0300-CREATE-FQN.                                                 APKOUTXT
023300     MOVE TR-FQN TO FQN-IDENT.                                    APKOUTXT
023400     MOVE FQN-GID TO FQN-TYPE.                                    APKOUTXT
023500     MOVE PAGE-COUNT TO FQN-PAGENUM.                              APKOUTXT
023600     MOVE LENGTH OF FQN-TRIPLET TO BIN2.                          APKOUTXT
023700     MOVE BIN2-2 TO FQN-LEN.                                      APKOUTXT
023800     MOVE FQN-TRIPLET TO OUT-SFDATA (OUT-RECLEN + 1 :             APKOUTXT
023900                                     LENGTH OF FQN-TRIPLET).      APKOUTXT
024000     ADD LENGTH OF FQN-TRIPLET TO OUT-RECLEN,                     APKOUTXT
024100                                  OUT-SFLEN.                      APKOUTXT
024200     SKIP2                                                        APKOUTXT
024300 0400-CREATE-COMMENT.                                             APKOUTXT
024400     MOVE TR-UCOMMENT (2:1) TO COMMENT-TYPE.                      APKOUTXT
024500     MOVE INSERT-PHRASE TO COMMENT-DATA.                          APKOUTXT
024600     ADD LENGTH OF INSERT-PHRASE, 1 GIVING BIN2.                  APKOUTXT
024700     MOVE PGMNAME TO COMMENT-DATA (BIN2 : LENGTH OF PGMNAME).     APKOUTXT
024800     ADD LENGTH OF PGMNAME, 1 TO BIN2.                            APKOUTXT
024900     MOVE RUN-DATE TO COMMENT-DATA (BIN2 : LENGTH OF RUN-DATE).   APKOUTXT
025000     ADD LENGTH OF RUN-DATE, 1 TO BIN2.                           APKOUTXT
025100     MOVE RUN-TIME TO COMMENT-DATA (BIN2 : LENGTH OF RUN-TIME).   APKOUTXT
025200     ADD LENGTH OF RUN-TIME TO BIN2.                              APKOUTXT
025300     ADD LENGTH OF COMMENT-LEN, LENGTH OF COMMENT-TYPE TO BIN2.   APKOUTXT
025400     MOVE BIN2-2 TO COMMENT-LEN.                                  APKOUTXT
025500     MOVE COMMENT-TRIPLET TO OUT-SFDATA                           APKOUTXT
025600                  (OUT-SFLEN - LENGTH OF OUT-SFINTRO + 1 : BIN2). APKOUTXT
025700                                                                  APKOUTXT
025800     ADD BIN2 TO OUT-RECLEN,                                      APKOUTXT
025900                 OUT-SFLEN.                                       APKOUTXT
