000100 PROCESS DYNAM NUMPROC(PFD) TRUNC(OPT) APOST LIB NOSEQ RES RENT   APKXPSEG
000200* LAST UPDATE ON 29 Jun 1995 AT 08:03:30 BY  VEND789 VERSION 01  *APKXPSEG
000300 ID DIVISION.                                                     APKXPSEG
000400 PROGRAM-ID. APKXPSEG.                                            APKXPSEG
000500 AUTHOR. TURETZKY--HYDRA.                                         APKXPSEG
000600 INSTALLATION. IBM BOULDER PROGRAMMING CENTER.                    APKXPSEG
000700               NOTE: REQUIRES VS COBOL II.  This program is an    APKXPSEG
000800               exit for ACIF (APKACIF,5648-062) that will print   APKXPSEG
000900               a list page segments referenced in a print job,    APKXPSEG
001000               and cause them to be excluded from the output      APKXPSEG
001100               resource library.                                  APKXPSEG
001200                                                                  APKXPSEG
001300               In order to use this exit, you must use the ACIF   APKXPSEG
001400               control statement RESTYPE=ALL for the list to be   APKXPSEG
001500               complete. RESTYPE=NONE will produce no list at     APKXPSEG
001600               all.  If you only wish to see certain type of      APKXPSEG
001700               resource, use RESTYPE to select it. Include the    APKXPSEG
001800               control RESEXIT=APKXPSEG to enable this exit, and  APKXPSEG
001900               include the load module in a dataset referenced    APKXPSEG
002000               in STEPLIB or elsewhere in the module search       APKXPSEG
002010               order.                                             APKXPSEG
002100                                                                  APKXPSEG
002200               To control resource inclusion in the output        APKXPSEG
002300               resource library, set the value of RES-ACTION      APKXPSEG
002400               appropriately.  Note that if resources are         APKXPSEG
002500               excluded, resources contained in overlays will     APKXPSEG
002600               not appear in the report because overlay contents  APKXPSEG
002700               will not be processed by ACIF.                     APKXPSEG
002800                                                                  APKXPSEG
002900               Method of operation: each resource name to be      APKXPSEG
003000               selected is written to the output file, along with APKXPSEG
003100               the resoure type. The exec PDS2RES can then be run APKXPSEG
003200               against the resource libraries to create a resourceAPKXPSEG
003300               object. For extremely large numbers (over 500) of  APKXPSEG
003400               resources this may be more efficient than using    APKXPSEG
003410               ACIF to do resource collection.                    APKXPSEG
003420                                                                  APKXPSEG
003500               You must allocate a DD named PAPKRSLS for the      APKXPSEG
003600               print file, with an LRECL of 84, BLKSIZE of        APKXPSEG
003610               n*84+4, VBA.                                       APKXPSEG
003700                                                                  APKXPSEG
003800               This program must either be compiled with the      APKXPSEG
003900               NORENT option or linked with IGZOPT with the       APKXPSEG
004000               RTEREUS option.  (See VS COBOL II Application      APKXPSEG
004100               Programming Guide, SC26-4045).                     APKXPSEG
004200                                                                  APKXPSEG
004300 DATE-WRITTEN. 23 FEB 93.                                         APKXPSEG
004400 DATE-COMPILED.                                                   APKXPSEG
004500 SECURITY. IBM SAMPLE CODE ONLY.                                  APKXPSEG
004600*/**************************************************************/ APKXPSEG
004700*/*   (C) COPYRIGHT IBM CORPORATION, 1991                      */ APKXPSEG
004800*/*                                                            */ APKXPSEG
004900*/*        >>>>>>>  IMPORTANT NOTICE   <<<<<<<<<<<             */ APKXPSEG
005000*/*                                                            */ APKXPSEG
005100*/*   THIS PROGRAM IS NOT SUPPORTED IN ANY WAY BY IBM.  IT     */ APKXPSEG
005200*/*   HAS NOT BEEN SUBJECTED TO ANY FORMAL IBM TESTING AND     */ APKXPSEG
005300*/*   IS DISTRIBUTED ON AN "AS-IS" BASIS WITHOUT ANY           */ APKXPSEG
005400*/*   WARRANTY EITHER EXPRESSED OR IMPLIED.  THE USE OF        */ APKXPSEG
005500*/*   THIS CODE OR ANY INFORMATION OR TECHNIQUES IMPLICIT      */ APKXPSEG
005600*/*   WITHIN IT IS THE SOLE RESPONSIBILITY OF THE CUSTOMER.    */ APKXPSEG
005700*/*   SUCH USE DEPENDS UPON THE CUSTOMER'S ABILITY TO          */ APKXPSEG
005800*/*   EVALUATE THE INFORMATION IN THE CONTEXT OF THEIR OWN     */ APKXPSEG
005900*/*   PARTICULAR OPERATING ENVIRONMENT.  THIS CODE HAS         */ APKXPSEG
006000*/*   OPERATED SUCCESSFULLY IN THE COMPUTING ENVIRONMENT AT    */ APKXPSEG
006100*/*   THE BOULDER PROGRAMMING CENTER.  THERE IS NO             */ APKXPSEG
006200*/*   GUARANTEE THAT IT WILL OPERATE CORRECTLY ELSEWHERE.      */ APKXPSEG
006300*/**************************************************************/ APKXPSEG
006400 TITLE 'ACIF RESOURCE REPORT EXIT'.                               APKXPSEG
006500 ENVIRONMENT DIVISION.                                            APKXPSEG
006600 CONFIGURATION SECTION.                                           APKXPSEG
006700 SOURCE-COMPUTER. IBM-370.                                        APKXPSEG
006800 OBJECT-COMPUTER. IBM-370.                                        APKXPSEG
006900 INPUT-OUTPUT SECTION.                                            APKXPSEG
007000 FILE-CONTROL.                                                    APKXPSEG
007100     SELECT PRINT-FILE ASSIGN TO PAPKXPSE.                        APKXPSEG
007200     SKIP2                                                        APKXPSEG
007300 DATA DIVISION.                                                   APKXPSEG
007400 FILE SECTION.                                                    APKXPSEG
007500 FD  PRINT-FILE                                                   APKXPSEG
007600     BLOCK CONTAINS 0                                             APKXPSEG
007700     LABEL RECORDS STANDARD                                       APKXPSEG
007800     RECORD VARYING DEPENDING ON PRINT-REC-LEN                    APKXPSEG
007900     RECORDING MODE V.                                            APKXPSEG
008000 01  PRINT-RECORD.                                                APKXPSEG
008100     05  PRINT-DATA          OCCURS 1 TO 80,                      APKXPSEG
008200                             DEPENDING ON PRINT-REC-LEN,          APKXPSEG
008300                             PIC X.                               APKXPSEG
008400     EJECT                                                        APKXPSEG
008500 WORKING-STORAGE SECTION.                                         APKXPSEG
008600 77  PGMNAME                 PIC X(8) VALUE 'APKXPSEG'.           APKXPSEG
008700 77  ABND-PGM                PIC X(8) VALUE 'ILBOABN0'.           APKXPSEG
008800 77  ABEND-CODE              PIC 9(4) BINARY VALUE 12.            APKXPSEG
008900 77  PRINT-REC-LEN           PIC 9(8) BINARY VALUE ZERO.          APKXPSEG
009000 77  MIN-REC-LEN             PIC 9(4) BINARY VALUE 9.             APKXPSEG
009100 77  MAX-REC-LEN             PIC 9(4) BINARY VALUE 81.            APKXPSEG
009200 77  LINE-COUNT              PIC S9(8) BINARY VALUE ZERO.         APKXPSEG
009300 77  PAGE-COUNT              PIC S9(8) BINARY VALUE ZERO.         APKXPSEG
009400 77  PAGE-LEN                PIC S9(8) BINARY VALUE 50.           APKXPSEG
009500 77  PSEG-CNTR               PIC S9(8) BINARY VALUE ZERO.         APKXPSEG
009600 77  OVLY-CNTR               PIC S9(8) BINARY VALUE ZERO.         APKXPSEG
009700 77  CSET-CNTR               PIC S9(8) BINARY VALUE ZERO.         APKXPSEG
009800 77  CPAGE-CNTR              PIC S9(8) BINARY VALUE ZERO.         APKXPSEG
009900 77  UNKNOWN-CNTR            PIC 9(4) BINARY VALUE ZERO.          APKXPSEG
010000 77  INCLUDE-RESOURCE        PIC X VALUE X'00'.                   APKXPSEG
010100 77  IGNORE-RESOURCE         PIC X VALUE X'01'.                   APKXPSEG
010200 77  FIRST-TIME-FLAG         PIC X VALUE LOW-VALUE.               APKXPSEG
010300     88  FIRST-TIME          VALUE LOW-VALUE.                     APKXPSEG
010400     88  NOT-FIRST-TIME      VALUE HIGH-VALUE.                    APKXPSEG
010500 77  CPAGE                   PIC X VALUE X'41'.                   APKXPSEG
010600 77  CSET                    PIC X VALUE X'40'.                   APKXPSEG
010700 77  PSEG                    PIC X VALUE X'FB'.                   APKXPSEG
010800 77  OVLY                    PIC X VALUE X'FC'.                   APKXPSEG
010900 77  FDEF-NAME               PIC X(14) VALUE 'FORMDEF'.           APKXPSEG
011000 77  CPAGE-NAME              PIC X(14) VALUE 'CODEPAGE'.          APKXPSEG
011100 77  CSET-NAME               PIC X(14) VALUE 'CHARACTER-SET'.     APKXPSEG
011200 77  PSEG-NAME               PIC X(14) VALUE 'PAGE-SEGMENT'.      APKXPSEG
011300 77  OVLY-NAME               PIC X(14) VALUE 'OVERLAY'.           APKXPSEG
011400     SKIP2                                                        APKXPSEG
011500         SKIP1                                                    APKXPSEG
011600 01  LINE-DETAIL.                                                 APKXPSEG
011700     05  LINE-CC             PIC X   VALUE SPACE.                 APKXPSEG
011800     05  FILLER              PIC X(02) VALUE SPACES.              APKXPSEG
011900     05  LINE-TYPE           PIC X(14) VALUE SPACES.              APKXPSEG
012000     05  FILLER              PIC X(02) VALUE SPACES.              APKXPSEG
012100     05  LINE-RESNAME        PIC X(8).                            APKXPSEG
012200         SKIP1                                                    APKXPSEG
012300 01  TIME-STAMP.                                                  APKXPSEG
012400     05  T-S-DAY             PIC 9(5).                            APKXPSEG
012500     05  FILLER              PIC X VALUE '/'.                     APKXPSEG
012600     05  T-S-TIME            PIC X(6).                            APKXPSEG
012700         SKIP1                                                    APKXPSEG
012800/ PASSED PARAMETERS.                                              APKXPSEG
012900 LINKAGE SECTION.                                                 APKXPSEG
013000 01  RES-PARMS.                                                   APKXPSEG
013100     05  RES-USTOR           POINTER.                             APKXPSEG
013200     05  RES-PFATTR          POINTER.                             APKXPSEG
013300     05  RES-RSNAME          PIC X(8).                            APKXPSEG
013400     05  RES-RSTYPE          PIC X.                               APKXPSEG
013500     05  RES-ACTION          PIC X.                               APKXPSEG
013600     05  RES-EOF-FLAG        PIC X.                               APKXPSEG
013700         88  RES-EOF         VALUE 'Y'.                           APKXPSEG
013800                                                                  APKXPSEG
013900 01  RES-UAREA               PIC X(16).                           APKXPSEG
014000                                                                  APKXPSEG
014100 01  RES-ATTR.                                                    APKXPSEG
014200     05  RES-CC              PIC XXX.                             APKXPSEG
014300     05  RES-CCTYPE          PIC X.                               APKXPSEG
014400     05  RES-CHARS           PIC X(20).                           APKXPSEG
014500     05  RES-FORMDEF         PIC X(8).                            APKXPSEG
014600     05  RES-PAGEDEF         PIC X(8).                            APKXPSEG
014700     05  RES-PRMODE          PIC X(8).                            APKXPSEG
014800     05  RES-TRC             PIC XXX.                             APKXPSEG
014900 TITLE 'INITIALIZATION AND MAIN LINE'.                            APKXPSEG
015000 PROCEDURE DIVISION USING RES-PARMS.                              APKXPSEG
015100 0010-UPDATE-TABLE.                                               APKXPSEG
015200     SET ADDRESS OF RES-UAREA TO RES-USTOR.                       APKXPSEG
015300     SET ADDRESS OF RES-ATTR TO RES-PFATTR.                       APKXPSEG
015400     SKIP1                                                        APKXPSEG
015500     IF FIRST-TIME                                                APKXPSEG
015600      THEN                                                        APKXPSEG
015700       OPEN OUTPUT PRINT-FILE;                                    APKXPSEG
015800       MOVE FDEF-NAME TO LINE-TYPE;                               APKXPSEG
015900       MOVE RES-FORMDEF TO LINE-RESNAME;                          APKXPSEG
016000       PERFORM 0120-PRINT-DETAIL;                                 APKXPSEG
016100       SET NOT-FIRST-TIME TO TRUE;                                APKXPSEG
016200     END-IF.                                                      APKXPSEG
016300     SKIP1                                                        APKXPSEG
016400     IF RES-EOF                                                   APKXPSEG
016500      THEN                                                        APKXPSEG
016600       CLOSE PRINT-FILE;                                          APKXPSEG
016700       SET FIRST-TIME TO TRUE;                                    APKXPSEG
016800       GOBACK;                                                    APKXPSEG
016900     END-IF.                                                      APKXPSEG
017000     SKIP1                                                        APKXPSEG
017100     EVALUATE RES-RSTYPE                                          APKXPSEG
017200* ACIF presents code pages each time they appear in a font, so    APKXPSEG
017300* there may be many occurences of the same codepage. Make sure    APKXPSEG
017400* we save only 1 of each.                                         APKXPSEG
017500      WHEN CPAGE                                                  APKXPSEG
017600       ADD 1 TO CPAGE-CNTR;                                       APKXPSEG
017700       MOVE CPAGE-NAME TO LINE-TYPE;                              APKXPSEG
017800       MOVE RES-RSNAME TO LINE-RESNAME;                           APKXPSEG
017900       PERFORM 0120-PRINT-DETAIL;                                 APKXPSEG
018000      WHEN CSET                                                   APKXPSEG
018100       ADD 1 TO CSET-CNTR;                                        APKXPSEG
018200       MOVE CSET-NAME TO LINE-TYPE;                               APKXPSEG
018300       MOVE RES-RSNAME TO LINE-RESNAME;                           APKXPSEG
018400       PERFORM 0120-PRINT-DETAIL;                                 APKXPSEG
018500      WHEN PSEG                                                   APKXPSEG
018600       ADD 1 TO PSEG-CNTR;                                        APKXPSEG
018700       MOVE PSEG-NAME TO LINE-TYPE;                               APKXPSEG
018800       MOVE RES-RSNAME TO LINE-RESNAME;                           APKXPSEG
018900       PERFORM 0120-PRINT-DETAIL;                                 APKXPSEG
019000      WHEN OVLY                                                   APKXPSEG
019100       ADD 1 TO OVLY-CNTR;                                        APKXPSEG
019200       MOVE OVLY-NAME TO LINE-TYPE;                               APKXPSEG
019300       MOVE RES-RSNAME TO LINE-RESNAME;                           APKXPSEG
019400       PERFORM 0120-PRINT-DETAIL;                                 APKXPSEG
019500      WHEN OTHER                                                  APKXPSEG
019600       ADD 1 TO UNKNOWN-CNTR;                                     APKXPSEG
019700     END-EVALUATE.                                                APKXPSEG
019800* The following omits or includes all resources.                  APKXPSEG
019900     MOVE IGNORE-RESOURCE TO RES-ACTION.                          APKXPSEG
020000*    MOVE INCLUDE-RESOURCE TO RES-ACTION.                         APKXPSEG
020100     GOBACK.                                                      APKXPSEG
020200 TITLE 'Produce Resource Used Report'.                            APKXPSEG
020300 0120-PRINT-DETAIL.                                               APKXPSEG
020400     MOVE LENGTH OF LINE-DETAIL TO PRINT-REC-LEN.                 APKXPSEG
020500     WRITE PRINT-RECORD FROM LINE-DETAIL.                         APKXPSEG
