000100 PROCESS DYNAM NUMPROC(PFD) TRUNC(OPT) APOST LIB NOSEQ RES RENT           
000200* LAST UPDATE ON 10 Aug 1995 AT 16:41:53 BY  VEND789 VERSION 01   *       
000300 ID DIVISION.                                                             
000400 PROGRAM-ID. ACIFINX.                                                     
000500 AUTHOR. TURETZKY--HYDRA.                                                 
000600 INSTALLATION. IBM BOULDER PROGRAMMING CENTER.                            
000700               NOTE: REQUIRES VS COBOL II.  This program is a             
000800               sample exit for ACIF (APKACIF,5648-062)                    
000900               demonstrating the use of the ACIF input exit.              
001000                                                                          
001100               In order to use this exit, include the control             
001200               INPEXIT=ACIFINX to enable this exit, and include           
001300               the load module in a dataset referenced in STEPLIB         
001400               or elsewhere in the module search order.  This             
001500               example uses the ACIFSAMP.LINEDATA data from the           
001600               ACIF examples disk and the ACSAMP FORMDEF and              
001700               PAGEDEF.                                                   
001800                                                                          
001900               This program will create an indexing NOP record            
002000               after the first line of the first page of each             
002100               document, remove the barcode data, and replace             
002200               the bottom page message with another phrase.               
002300                                                                          
002400               Method of operation: each input record is examined         
002500               for an ANSI skip to channel 1, used to indicate            
002600               top- of-form. The account number on this line is           
002700               looked up in a table, and a NOP containing the             
002800               store name is inserted.                                    
002900                                                                          
003000               If the last line of the page contains a                    
003100               continuation message (identified by a skip to              
003200               channel 4), a flag is set. If the page is not              
003300               continued, then the message text on the skip to            
003400               channel 3 is replaced with new text. The barcode           
003500               information, indicated by a skip to channel 12,            
003600               is removed by setting the record delete flag.              
003700                                                                          
003800               This program must either be compiled with the              
003900               NORENT option or linked with IGZOPT with the               
004000               RTEREUS option.  (See VS COBOL II Application              
004100               Programming Guide, SC26-4045).                             
004200                                                                          
004300 DATE-WRITTEN. 23 SEP 93.                                                 
004400 DATE-COMPILED.                                                           
004500 SECURITY. IBM SAMPLE CODE ONLY.                                          
004600*/**************************************************************/         
004700*/*   (C) COPYRIGHT IBM CORPORATION, 1993                      */         
004800*/*                                                            */         
004900*/*        >>>>>>>  IMPORTANT NOTICE   <<<<<<<<<<<             */         
005000*/*                                                            */         
005100*/*   THIS PROGRAM IS NOT SUPPORTED IN ANY WAY BY IBM.  IT     */         
005200*/*   HAS NOT BEEN SUBJECTED TO ANY FORMAL IBM TESTING AND     */         
005300*/*   IS DISTRIBUTED ON AN "AS-IS" BASIS WITHOUT ANY           */         
005400*/*   WARRANTY EITHER EXPRESSED OR IMPLIED.  THE USE OF        */         
005500*/*   THIS CODE OR ANY INFORMATION OR TECHNIQUES IMPLICIT      */         
005600*/*   WITHIN IT IS THE SOLE RESPONSIBILITY OF THE CUSTOMER.    */         
005700*/*   SUCH USE DEPENDS UPON THE CUSTOMER'S ABILITY TO          */         
005800*/*   EVALUATE THE INFORMATION IN THE CONTEXT OF THEIR OWN     */         
005900*/*   PARTICULAR OPERATING ENVIRONMENT.  THIS CODE HAS         */         
006000*/*   OPERATED SUCCESSFULLY IN THE COMPUTING ENVIRONMENT AT    */         
006100*/*   THE BOULDER PROGRAMMING CENTER.  THERE IS NO             */         
006200*/*   GUARANTEE THAT IT WILL OPERATE CORRECTLY ELSEWHERE.      */         
006300*/**************************************************************/         
006400 TITLE 'ACIF Sample Input Exit'.                                          
006500 ENVIRONMENT DIVISION.                                                    
006600 CONFIGURATION SECTION.                                                   
006700 SOURCE-COMPUTER. IBM-370.                                                
006800 OBJECT-COMPUTER. IBM-370.                                                
006900     EJECT                                                                
007000 DATA DIVISION.                                                           
007100 WORKING-STORAGE SECTION.                                                 
007200 77  PGMNAME                 PIC X(8) VALUE 'ACIFINX'.                    
007300 77  ABND-PGM                PIC X(8) VALUE 'ILBOABN0'.                   
007400 77  ABEND-CODE              PIC 9(4) BINARY VALUE 12.                    
007500 77  AFPWRITE                PIC X(8) VALUE 'AFPWRITE'.                   
007600* The following are values for positions and lengths of items             
007700* in the input lines.                                                     
007800 77  REPT-LEN                PIC 9(4) BINARY VALUE 3.                     
007900 77  DATE-LEN                PIC 9(4) BINARY VALUE 8.                     
008000 77  PAGE-DISP               PIC ZZ,ZZ9.                                  
008100 77  CC-TOF                  PIC X.                                       
008200     88  ANSI-TOF            VALUE '1'.                                   
008300     88  MACH-TOF            VALUE X'8B'.                                 
008400 77  CC-CONTINUED            PIC X.                                       
008500     88  ANSI-CONTINUED      VALUE '4'.                                   
008600     88  MACH-CONTINUED      VALUE X'A3'.                                 
008700 77  CC-MESSAGE              PIC X.                                       
008800     88  ANSI-MESSAGE        VALUE '3'.                                   
008900     88  MACH-MESSAGE        VALUE X'9B'.                                 
009000 77  CC-BARCODE              PIC X.                                       
009100     88  ANSI-BARCODE        VALUE 'C'.                                   
009200     88  MACH-BARCODE        VALUE X'F3'.                                 
009300     SKIP1                                                                
009400 01  MISC-SAVED-DATA.                                                     
009500     05  FIRST-LINE-FLAG     PIC X VALUE LOW-VALUE.                       
009600         88 FIRST-LINE       VALUE HIGH-VALUE.                            
009700         88 NOTFIRST-LINE    VALUE LOW-VALUE.                             
009800     05  INSERT-FLAG         PIC X VALUE LOW-VALUE.                       
009900         88 INSERT-LINE      VALUE HIGH-VALUE.                            
010000         88 NOINSERT-LINE    VALUE LOW-VALUE.                             
010100     05  LINE-COUNT          PIC S9(8) BINARY VALUE ZERO.                 
010200     05  PAGE-COUNT          PIC S9(8) BINARY VALUE ZERO.                 
010300     SKIP2                                                                
010400* This is the data portion of the NOP record. It specifies                
010500* the name of division and store for indexing.                            
010600 01  NOP-DATA.                                                            
010700     05  FILLER              PIC X(11) VALUE '**INDEX**: '.               
010800     05  NOP-DIVISION-CODE   PIC 99.                                      
010900     05  NOP-DIVISION-NAME   PIC X(12).                                   
011000     05  FILLER              PIC X  VALUE SPACE.                          
011100     05  NOP-STORE-CODE      PIC 99.                                      
011200     05  NOP-STORE-NAME      PIC X(12).                                   
011300     SKIP2                                                                
011400 01  RECORD-BUFFERS.                                                      
011500     05  SAVED-LINE-RECLEN   PIC 9(4) BINARY.                             
011600     05  INSERT-RECLEN       PIC 9(4) BINARY.                             
011700     05  SAVED-LINE-BUFFER   PIC X(8192).                                 
011800     05  INSERT-RECORD-BUFFER PIC X(8192).                                
011900     05  COPY-PHRASE.                                                     
012000         10  COPY-PHRASE-CC  PIC X.                                       
012100         10  FILLER          PIC X(30) VALUE                              
012200                             '***COPY***COPY***COPY***COPY**'.            
012300         10  FILLER          PIC X(30) VALUE                              
012400                             '*COPY***COPY***COPY***COPY****'.            
012500     SKIP2                                                                
012600 01  LOCATION-TABLES.                                                     
012700     05  DIV-DIVISION-VALUES.                                             
012800         10 FILLER           PIC 99    VALUE 01.                          
012900         10 FILLER           PIC X(12) VALUE 'BALDMTN BIKE'.              
013000         10 FILLER           PIC 99    VALUE 02.                          
013100         10 FILLER           PIC X(12) VALUE 'WeeBee Shoes'.              
013200         10 FILLER           PIC 99    VALUE 03.                          
013300         10 FILLER           PIC X(12) VALUE 'TennisRacket'.              
013400         10 FILLER           PIC 99    VALUE 04.                          
013500         10 FILLER           PIC X(12) VALUE 'U-SELLUM    '.              
013600     05  DIV-DIVISION           REDEFINES DIV-DIVISION-VALUES.            
013700         10 DIV-DIV-TABLE OCCURS 4                                        
013800                             INDEXED BY DIV-DIV-INDX.                     
013900             15 DIV-DIV-NUM  PIC 99.                                      
014000             15 DIV-DIV-NAME PIC X(12).                                   
014100     05  DIV-STORE-VALUES.                                                
014200         10 FILLER           PIC 99    VALUE 01.                          
014300         10 FILLER           PIC X(12) VALUE 'N. Chicago  '.              
014400         10 FILLER           PIC 99    VALUE 02.                          
014500         10 FILLER           PIC X(12) VALUE 'Breckenridge'.              
014600         10 FILLER           PIC 99    VALUE 03.                          
014700         10 FILLER           PIC X(12) VALUE 'Rustbelt, MI'.              
014800         10 FILLER           PIC 99    VALUE 04.                          
014900         10 FILLER           PIC X(12) VALUE 'Aspen, CO   '.              
015000         10 FILLER           PIC 99    VALUE 05.                          
015100         10 FILLER           PIC X(12) VALUE 'Masonville  '.              
015200         10 FILLER           PIC 99    VALUE 06.                          
015300         10 FILLER           PIC X(12) VALUE 'Albuquerque '.              
015400         10 FILLER           PIC 99    VALUE 07.                          
015500         10 FILLER           PIC X(12) VALUE 'Bastogne    '.              
015600         10 FILLER           PIC 99    VALUE 08.                          
015700         10 FILLER           PIC X(12) VALUE 'Florence    '.              
015800         10 FILLER           PIC 99    VALUE 09.                          
015900         10 FILLER           PIC X(12) VALUE 'Madrid      '.              
016000     05  DIV-STORE              REDEFINES DIV-STORE-VALUES.               
016100         10 DIV-STORE-TABLE  OCCURS 9                                     
016200                             INDEXED BY DIV-STORE-INDX.                   
016300             15 DIV-STORE-NUM  PIC 99.                                    
016400             15 DIV-STORE-NAME PIC X(12).                                 
016500         SKIP1                                                            
016600/ AFP STRUCTURED FIELD DEFINITIONS.                                       
016700     COPY STRFLDS SUPPRESS.                                               
016800/ PASSED PARAMETERS.                                                      
016900 LINKAGE SECTION.                                                         
017000 01  INP-PARMS.                                                           
017100     05  INP-USTOR           POINTER.                                     
017200     05  INP-PFATTR          POINTER.                                     
017300     05  INP-RECPTR          POINTER.                                     
017400     05  FILLER              POINTER.                                     
017500     05  INP-RECLEN          PIC 9(4) BINARY.                             
017600     05  FILLER              PIC XX.                                      
017700     05  INP-REQUEST         PIC X.                                       
017800         88  INP-USE         VALUE X'00'.                                 
017900         88  INP-DELETE      VALUE X'01'.                                 
018000         88  INP-INSERT      VALUE X'02'.                                 
018100     05  INP-EOF-FLAG        PIC X.                                       
018200         88  INP-EOF         VALUE 'Y'.                                   
018300                                                                          
018400 01  INP-UAREA               PIC X(16).                                   
018500                                                                          
018600 01  INP-ATTR.                                                            
018700     05  INP-CC              PIC XXX.                                     
018800     05  INP-CCTYPE          PIC X.                                       
018900         88  INP-ANSI-CC     VALUE 'A'.                                   
019000         88  INP-MACH-CC     VALUE 'M'.                                   
019100     05  INP-CHARS           PIC X(20).                                   
019200     05  INP-FORMDEF         PIC X(8).                                    
019300     05  INP-PAGEDEF         PIC X(8).                                    
019400     05  INP-PRMODE          PIC X(8).                                    
019500     05  INP-TRC             PIC XXX.                                     
019600                                                                          
019700* This is a template for the input record, pointed to by                  
019800* INP-RECPTR. The record's actual length is given by                      
019900* INP-RECLEN.                                                             
020000 01  INP-LINE.                                                            
020100     05  INP-CCVAL           PIC X.                                       
020200     05  INP-LINEDATA        PIC X(8191).                                 
020300     05  INP-FIRSTLINE       REDEFINES INP-LINEDATA.                      
020400         10  INP-DATE        PIC X(12).                                   
020500         10  FILLER          PIC X.                                       
020600         10  INP-ACCOUNT.                                                 
020700             15  INP-DIV-CODE   PIC 99.                                   
020800             15  FILLER         PIC X.                                    
020900             15  INP-STORE-CODE PIC 99.                                   
021000             15  FILLER         PIC X.                                    
021100             15  INP-ACCOUNT-NO PIC 99.                                   
021200     SKIP1                                                                
021300 TITLE 'Initialization and Main Line'.                                    
021400 PROCEDURE DIVISION USING INP-PARMS.                                      
021500* make work area, attributes, and input line addressable.                 
021600     SET ADDRESS OF INP-UAREA TO INP-USTOR.                               
021700     SET ADDRESS OF INP-ATTR TO INP-PFATTR.                               
021800     SET ADDRESS OF INP-LINE TO INP-RECPTR.                               
021900     MOVE ZERO TO RETURN-CODE.                                            
022000* no special action is necessary at EOF.                                  
022100     IF INP-EOF                                                           
022200      THEN                                                                
022300       DISPLAY PGMNAME, ' EOF REACHED.';                                  
022400       MOVE PAGE-COUNT TO PAGE-DISP;                                      
022500       DISPLAY PGMNAME, PAGE-DISP, ' Pages processed.';                   
022600       GOBACK;                                                            
022700     END-IF.                                                              
022800* The print file attributes are used to determine the type                
022900* of carriage control to test for for top-of-form.                        
023000* For purposes of this example, we assume the file will                   
023100* always have carriage control, and if machine control the                
023200* skip to channel 1 immediate is used for new pages.                      
023300     IF INP-ANSI-CC                                                       
023400      THEN                                                                
023500       SET ANSI-TOF       TO TRUE;                                        
023600       SET ANSI-MESSAGE   TO TRUE;                                        
023700       SET ANSI-CONTINUED TO TRUE;                                        
023800       SET ANSI-BARCODE   TO TRUE;                                        
023900      ELSE                                                                
024000       SET MACH-MESSAGE   TO TRUE;                                        
024100       SET MACH-CONTINUED TO TRUE;                                        
024200       SET MACH-BARCODE   TO TRUE;                                        
024300       SET MACH-TOF       TO TRUE.                                        
024400     SKIP1                                                                
024500* If the insert flag is set then a record has been placed in              
024600* the saved buffer to be inserted. The record is put into                 
024700* the ACIF buffer and returned to ACIF with no further                    
024800* processing.                                                             
024900     IF INSERT-LINE                                                       
025000      THEN                                                                
025100       MOVE SAVED-LINE-RECLEN TO INP-RECLEN;                              
025200       MOVE SAVED-LINE-BUFFER TO INP-LINE (1:SAVED-LINE-RECLEN);          
025300       SET NOINSERT-LINE TO TRUE;                                         
025400       GOBACK;                                                            
025500     END-IF.                                                              
025600     SKIP1                                                                
025700* The carriage control character is tested for top-of-form.               
025800* This identifies the first line of a page. The account                   
025900* number division and store code are found in the lookup                  
026000* tables, and a NOP record is inserted containing the names               
026100* for use as an indexing key.                                             
026200* If machine carriage control is used, then the first                     
026300* print line is the line after the top-of-form. A flag                    
026400* is set to cause this line to be treated as the top.                     
026500     IF FIRST-LINE OR (INP-CCVAL = CC-TOF)                                
026600      THEN                                                                
026700       IF ANSI-TOF OR FIRST-LINE                                          
026800        THEN                                                              
026900* This is a top-of-form line (or the first line on the page),             
027000* so extract the accounting information and create the NOP                
027100* line to be inserted. Control is then returned to ACIF and               
027200* the original record inserted at the next call.                          
027300         SET NOTFIRST-LINE TO TRUE;                                       
027400         ADD 1 TO PAGE-COUNT;                                             
027500         MOVE 1 TO LINE-COUNT;                                            
027600         PERFORM 0200-LOOKUP-ACCOUNT;                                     
027700         MOVE LENGTH OF NOP-DATA TO INSERT-RECLEN,                        
027800         CALL AFPWRITE USING SF-NOP,                                      
027900                             NOP-DATA,                                    
028000                             BY CONTENT LENGTH OF NOP-DATA,               
028100                             BY REFERENCE INSERT-RECLEN,                  
028200                             INSERT-RECORD-BUFFER;                        
028300         PERFORM 0100-INSERT-RECORD;                                      
028400        ELSE                                                              
028500         SET FIRST-LINE TO TRUE;                                          
028600       END-IF;                                                            
028700      ELSE                                                                
028800       ADD 1 TO LINE-COUNT;                                               
028900     END-IF.                                                              
029000     SKIP1                                                                
029100* Check for the page bottom lines by checking the carriage skips.         
029200     EVALUATE INP-CCVAL;                                                  
029300      WHEN CC-MESSAGE                                                     
029400*      Replace the message line with the COPY line. The original          
029500*      line buffer from ACIF is replaced and the length adjusted          
029600*      to include carriage control and the new data. The                  
029700*      INP-REQUEST flag is unchanged, since ACIF sets it to USE.          
029800       MOVE LENGTH OF COPY-PHRASE TO INP-RECLEN;                          
029900       MOVE CC-MESSAGE TO COPY-PHRASE-CC;                                 
030000       MOVE COPY-PHRASE TO INP-LINE (1:LENGTH OF COPY-PHRASE);            
030100      WHEN CC-CONTINUED                                                   
030200*      The continued message must appear before the COPY phrase           
030300*      because continued uses channel 4 and the message uses              
030400*      channel 3 to control placement. Therefore, the continued           
030500*      line is saved, the insert flag set, the COPY phrase                
030600*      replaces the continued message, and the continued message          
030700*      is returned on the next call.                                      
030800       MOVE CC-MESSAGE TO COPY-PHRASE-CC;                                 
030900       MOVE LENGTH OF COPY-PHRASE TO INSERT-RECLEN;                       
031000       MOVE COPY-PHRASE TO INSERT-RECORD-BUFFER                           
031100                           (1:LENGTH OF COPY-PHRASE);                     
031200       PERFORM 0100-INSERT-RECORD;                                        
031300      WHEN CC-BARCODE                                                     
031400*      The barcode line is deleted by setting the delete flag.            
031500       SET INP-DELETE TO TRUE;                                            
031600      WHEN OTHER                                                          
031700*      all other lines are returned unmolested.                           
031800       CONTINUE;                                                          
031900     END-EVALUATE.                                                        
032000     SKIP1                                                                
032100     GOBACK.                                                              
032200     EJECT                                                                
032300 0100-INSERT-RECORD.                                                      
032400* Insert a record before the current record. The current record           
032500* from ACIF is saved in a buffer and and the new record returned          
032600* to ACIF with the insert flag set.                                       
032700* Our own insert flag is set so that the original record can be           
032800* returned on the next call.                                              
032900     SUBTRACT 1 FROM LINE-COUNT.                                          
033000     MOVE INP-RECLEN TO SAVED-LINE-RECLEN.                                
033100     MOVE INP-LINE (1:INP-RECLEN) TO SAVED-LINE-BUFFER.                   
033200     MOVE INSERT-RECLEN TO INP-RECLEN.                                    
033300     MOVE INSERT-RECORD-BUFFER TO INP-LINE (1:INSERT-RECLEN).             
033400     SET INSERT-LINE TO TRUE.                                             
033500     SET INP-INSERT TO TRUE.                                              
033600     SKIP3                                                                
033700 0200-LOOKUP-ACCOUNT.                                                     
033800* This routine searches the division code and store code tables.          
033900* The codes and names are placed into an AFP NOP record for use           
034000* by the ACIF indexer so that names will show in the Viewer               
034100* index window instead of just codes.                                     
034200     SET DIV-DIV-INDX TO 1.                                               
034300     SEARCH DIV-DIV-TABLE                                                 
034400      AT END                                                              
034500       MOVE 'UNKNOWN' TO NOP-DIVISION-NAME;                               
034600      WHEN DIV-DIV-NUM (DIV-DIV-INDX) = INP-DIV-CODE                      
034700       MOVE DIV-DIV-NAME (DIV-DIV-INDX) TO                                
034800            NOP-DIVISION-NAME;                                            
034900     END-SEARCH.                                                          
035000     SET DIV-STORE-INDX TO 1.                                             
035100     SEARCH DIV-STORE-TABLE                                               
035200      AT END                                                              
035300       MOVE 'UNKNOWN' TO NOP-STORE-NAME;                                  
035400      WHEN DIV-STORE-NUM (DIV-STORE-INDX) = INP-STORE-CODE                
035500       MOVE DIV-STORE-NAME (DIV-STORE-INDX) TO                            
035600            NOP-STORE-NAME;                                               
035700     END-SEARCH.                                                          
035800     MOVE INP-DIV-CODE TO NOP-DIVISION-CODE.                              
035900     MOVE INP-STORE-CODE TO NOP-STORE-CODE.                               
036000 TITLE 'FORMAT AFPDS RECORD'.                                             
036100 ID DIVISION.                                                             
036200* This routine takes the structured field type, data, and data            
036300* length and formats an AFP record and places it in the                   
036400* exit's buffer.                                                          
036500 PROGRAM-ID. AFPWRITE COMMON.                                             
036600 DATA DIVISION.                                                           
036700 WORKING-STORAGE SECTION.                                                 
036800 77  SF-CC                       PIC X VALUE X'5A'.                       
036900 LINKAGE SECTION.                                                         
037000 01  AFP-TYPE                    PIC X(3).                                
037100 01  AFP-DATA                    PIC X(8192).                             
037200 01  AFP-DATA-LENGTH             PIC 9(9) BINARY.                         
037300 01  AFP-INSERT-LEN              PIC 9(4) BINARY.                         
037400     SKIP1                                                                
037500 01  SF-RECORD.                                                           
037600     05  SF-INTRODUCER.                                                   
037700         10 SF-INTRO-CC      PIC X.                                       
037800         10 SF-INTRO-LEN     PIC 9(4) BINARY.                             
037900         10 SF-INTRO-TYPE    PIC X(3).                                    
038000         10 SF-INTRO-FLAG    PIC X.                                       
038100         10 SF-INTRO-SEQNUM  PIC 9(4) BINARY.                             
038200     05  SF-DATA             PIC X(8192).                                 
038300 SKIP3                                                                    
038400 PROCEDURE DIVISION USING AFP-TYPE,                                       
038500                          AFP-DATA,                                       
038600                          AFP-DATA-LENGTH,                                
038700                          AFP-INSERT-LEN,                                 
038800                          SF-RECORD.                                      
038900* set the final record length (introducer plus data), which is            
039000* found in the introducer length field, move in the introducer            
039100* and the data, then write the record.                                    
039200     ADD LENGTH OF SF-INTRODUCER, AFP-DATA-LENGTH GIVING                  
039300         AFP-INSERT-LEN.                                                  
039400     SUBTRACT 1 FROM AFP-INSERT-LEN GIVING SF-INTRO-LEN.                  
039500     MOVE SF-CC TO     SF-INTRO-CC.                                       
039600     MOVE AFP-TYPE TO SF-INTRO-TYPE.                                      
039700     MOVE LOW-VALUE TO SF-INTRO-FLAG.                                     
039800     MOVE ZERO TO      SF-INTRO-SEQNUM.                                   
039900     MOVE AFP-DATA (1 : AFP-DATA-LENGTH) TO SF-DATA                       
040000                                         (1 : AFP-DATA-LENGTH).           
040100     EXIT PROGRAM.                                                        
040200 END PROGRAM AFPWRITE.                                                    
040300 SKIP1                                                                    
040400 END PROGRAM ACIFINX.                                                     
