//ACIF     EXEC PGM=APKACIF,REGION=20M,TIME=(,30)                               
//*===============================================================*             
//* RUN APK, CREATING OUTPUT AND A RESOURCE LIBRARY               *             
//*===============================================================*             
//STEPLIB  DD  DSN=ACIF.APKACIF.SAPKMOD1,DISP=SHR                               
//         DD  DSN=COB2.V131.COB2LIB,DISP=SHR                                   
//         DD  DSN=<cobol.load.lib>,DISP=SHR                                    
//INPUT DD  DISP=SHR,DSN=<my.input.file>                                        
//SYSIN DD *                                                                    
 /* convert and produce resource list file */                                   
 FDEFLIB=<my.fdeflib>                                                           
 FIELD1 = 0,21,16             /* 1ST FIELD                 */                   
 FONTLIB= <my.fontlib>                                                          
 OVLYLIB= <my.ovlylib>                                                          
 FORMDEF  = F1A10010           /* FORMDEF NAME              */                  
 IMAGEOUT = ASIS                   /* INPUT IMAGE UNCONVERTED   */              
 INDEXOBJ=ALL                                                                   
 INDEX1='DOCUMENT KEY',FIELD1                                                   
 INPUTDD= INPUT         /* INPUT FILE DDNAME         */                         
 OUTPUTDD = OUTPUT      /* OUTPUT FILE DDNAME        */                         
 PAGEDEF  = P1XXXX               /*  PAGEDEF NAME             */                
 PDEFLIB= <my.pdeflib>                                                          
 PSEGLIB= <my.pseglib>                                                          
 RESOBJDD = RESLIB                                                              
 RESTYPE = ALL                                                                  
 TRC=YES                                                                        
 TRIGGER1=*,8,'KEY:'                                                            
 RESEXIT= APKXPSEG              /* RESOURCE EXIT NAME        */                 
 RESFILE = PDS          /* resource file type        */                         
/*                                                                              
//OUTPUT DD DSN=NULLFILE,DISP=(NEW,CATLG),                                      
//         SPACE=(32760,(150,150),RLSE),UNIT=SYSDA,                             
//         DCB=(LRECL=32756,BLKSIZE=32760,RECFM=VBM,DSORG=PS)                   
//INDEX DD DSN=NULLFILE,DISP=(NEW,CATLG),                                       
//         SPACE=(32760,(15,15),RLSE),UNIT=SYSDA,                               
//         DCB=(LRECL=32756,BLKSIZE=32760,RECFM=VBM,DSORG=PS)                   
//RESLIB DD DSN=<my>.APKXPSEG.RESLIB,DISP=(NEW,CATLG),                          
//         SPACE=(TRK,(150,250,45),RLSE),UNIT=SYSDA,                            
//         DCB=(LRECL=32756,BLKSIZE=32760,RECFM=VBM,DSORG=PO)                   
//SYSPRINT DD SYSOUT=*                                                          
//SYSUDUMP DD  SYSOUT=*                                                         
//SYSABOUT DD  SYSOUT=*                                                         
//SYSOUT   DD  SYSOUT=*                                                         
//PAPKXPSE DD  DSN=&&RESLIST,DISP=(,PASS,DELETE),                               
//         DCB=(BLKSIZE=8900,RECFM=VBA),SPACE=(8900,(50,50),RLSE),              
//         UNIT=VIO                                                             
// ENDIF                                                                        
// IF (ACIF.RC <= 4) THEN                                                       
//MAKERES  EXEC PGM=IKJEFT01,REGION=4M                                  00040021
//INLIST   DD  DSN=&&RESLIST,DISP=(OLD,DELETE)                                  
//* note that ISPF limits processing to no more than 4 libraries.               
//RESLIB   DD  DISP=SHR,DSN=<my.pdeflib>                                        
//         DD  DISP=SHR,DSN=<my.fontlib>                                        
//         DD  DISP=SHR,DSN=<my.ovlylib>                                        
//         DD  DISP=SHR,DSN=<my.fdeflib>                                        
//RESOUT   DD  DSN=<my>.APKXPSEG.RESOUT,DISP=(,CATLG),UNIT=SYSDA,               
//         SPACE=(32760,(250,150),RLSE),                                        
//         DCB=(LRECL=32756,BLKSIZE=32760,RECFM=VBM)                            
//SYSPROC  DD  DISP=SHR,DSN=<my.exec.lib>                                       
//SYSTSPRT DD  SYSOUT=*                                                         
//*YSUDUMP DD  SYSOUT=*                                                         
//ISPCTL0  DD  UNIT=VIO,SPACE=(CYL,(1,1)),                                      
//            DCB=(LRECL=80,RECFM=FB,BLKSIZE=800)                               
//ISPCTL1  DD  UNIT=VIO,SPACE=(CYL,(1,1)),                                      
//            DCB=(LRECL=80,RECFM=FB,BLKSIZE=800)                               
//ISPCTL2  DD  UNIT=VIO,SPACE=(CYL,(1,1)),                                      
//            DCB=(LRECL=80,RECFM=FB,BLKSIZE=800)                               
//ISPWRK1  DD  UNIT=VIO,SPACE=(CYL,(1,1)),                                      
//            DCB=(LRECL=256,RECFM=FB,BLKSIZE=2560)                             
//ISPWRK2  DD  UNIT=VIO,SPACE=(CYL,(1,1)),                                      
//            DCB=(LRECL=256,RECFM=FB,BLKSIZE=2560)                             
//ISPLLIB  DD  DSN=ISPF.SISPLOAD,DISP=SHR         /* ISPF V4      */            
//         DD  DSN=ISPF.SISPLPA,DISP=SHR          /* ISPF V4      */            
//ISPMLIB  DD  DSN=ISPF.SISPMENU,DISP=SHR         /* ISPF V4      */            
//ISPPLIB  DD  DSN=ISPF.SISPPENU,DISP=SHR         /* ISPF V4      */            
//         DD  DSN=ISPF.ISRPENU,DISP=SHR          /* ISPF V4      */            
//ISPSLIB  DD  DSN=ISPF.SISPSENU,DISP=SHR         /* ISPF V4      */            
//ISPTLIB  DD  DSN=ISPF.SISPTENU,DISP=SHR         /* ISPF V4      */            
//ISRCLIB  DD  DSN=ISR.ISRCLIB,DISP=SHR           /* ISPF V4      */            
//ISPPROF  DD  UNIT=VIO,SPACE=(TRK,(1,1,1)),                                    
//             DCB=(LRECL=80,BLKSIZE=3120,RECFM=FB,DSORG=PO)                    
//ISPLOG   DD  SYSOUT=*,DCB=(LRECL=125,BLKSIZE=129,RECFM=VA)                    
//SYSTSIN  DD  *                                                                
 "ISPSTART CMD(PDS2RES INLIST RESLIB RESOUT (BATCH Y TRACE O)"                  
/*                                                                              
// ENDIF                                                                        
