000100* LAST UPDATE ON 4 Aug 1994 AT 11:18:11 BY  VEND789 VERSION 01   *AFPXTRCT
000200*PROCESS DYNAM NUMPROC(PFD) TRUNC(OPT) APOST LIB NOSEQ RES RENT   AFPXTRCT
000300 ID DIVISION.                                                     AFPXTRCT
000400 PROGRAM-ID. AFPXTRCT.                                            AFPXTRCT
000500 AUTHOR. B. E. HAAN, IBM                                          AFPXTRCT
000600         H. Turetzky, HYDRA                                       AFPXTRCT
000700     This program reads a file of control statments which select  AFPXTRCT
000800     pages indexed by AFPINDEX.                                   AFPXTRCT
000900                                                                  AFPXTRCT
001000     The index is a VSAM file created by AFPINDEX from a MO:DCA   AFPXTRCT
001100     index object. The index points to records in a VSAM ESDS fileAFPXTRCT
001200     which contains a MO:DCA datastream that corresponds to the   AFPXTRCT
001300     MO:DCA index. The control statmemts contain a key (or genericAFPXTRCT
001400     key or a key range) that select from the index the pages to  AFPXTRCT
001500     be extracted from the ESDS file. The keys correspond to TLE  AFPXTRCT
001600     attribute values from the original MO:DCA index.             AFPXTRCT
001700                                                                  AFPXTRCT
001800     The extracted pages are treated as a single document. A      AFPXTRCT
001900     MO:DCA Begin Document record is copied from the referenced   AFPXTRCT
002000     document,AFPXTRCT followed by the selected groups of pages   AFPXTRCT
002100     and then by an      AFPXTRCT End Document record.            AFPXTRCT
002110     AFPXTRCT                                                     AFPXTRCT
002200                                                                  AFPXTRCT
002300   Possible Enhancements                                          AFPXTRCT
002400     A new MO:DCA index file could be created, containing group   AFPXTRCT
002500     indexes (IELs and TLEs) for the pages as well as page-level  AFPXTRCT
002600     indexes (IELs).                                              AFPXTRCT
002700                                                                  AFPXTRCT
002800     Other enhancements include extracting documents from more    AFPXTRCT
002900     than one index/page set, and merging the associated resource AFPXTRCT
003000     files. An example of inserting text (such as bar code and    AFPXTRCT
003100     mailer marking information) may also be provided.            AFPXTRCT
003200     The control cards could be changed to use INDEXn= keywords.  AFPXTRCT
003300     skip3                                                        AFPXTRCT
003400 INSTALLATION. IBM BOULDER PROGRAMMING CENTER.                    AFPXTRCT
003500 DATE-WRITTEN. JUN 93.                                            AFPXTRCT
003600 DATE-COMPILED.                                                   AFPXTRCT
003700 SECURITY. IBM SAMPLE CODE ONLY.                                  AFPXTRCT
003800*/**************************************************************/ AFPXTRCT
003900*/*   (C) COPYRIGHT IBM CORPORATION, 1993                      */ AFPXTRCT
004000*/*                                                            */ AFPXTRCT
004100*/*        >>>>>>>  IMPORTANT NOTICE   <<<<<<<<<<<             */ AFPXTRCT
004200*/*                                                            */ AFPXTRCT
004300*/*   THIS PROGRAM IS NOT SUPPORTED IN ANY WAY BY IBM.  IT     */ AFPXTRCT
004400*/*   HAS NOT BEEN SUBJECTED TO ANY FORMAL IBM TESTING AND     */ AFPXTRCT
004500*/*   IS DISTRIBUTED ON AN "AS-IS" BASIS WITHOUT ANY           */ AFPXTRCT
004600*/*   WARRANTY EITHER EXPRESSED OR IMPLIED.  THE USE OF        */ AFPXTRCT
004700*/*   THIS CODE OR ANY INFORMATION OR TECHNIQUES IMPLICIT      */ AFPXTRCT
004800*/*   WITHIN IT IS THE SOLE RESPONSIBILITY OF THE CUSTOMER.    */ AFPXTRCT
004900*/*   SUCH USE DEPENDS UPON THE CUSTOMER'S ABILITY TO          */ AFPXTRCT
005000*/*   EVALUATE THE INFORMATION IN THE CONTEXT OF THEIR OWN     */ AFPXTRCT
005100*/*   PARTICULAR OPERATING ENVIRONMENT.  THIS CODE HAS         */ AFPXTRCT
005200*/*   OPERATED SUCCESSFULLY IN THE COMPUTING ENVIRONMENT AT    */ AFPXTRCT
005300*/*   THE BOULDER PROGRAMMING CENTER.  THERE IS NO             */ AFPXTRCT
005400*/*   GUARANTEE THAT IT WILL OPERATE CORRECTLY ELSEWHERE.      */ AFPXTRCT
005500*/**************************************************************/ AFPXTRCT
005600 TITLE 'AFP Page Extractor'.                                      AFPXTRCT
005700 ENVIRONMENT DIVISION.                                            AFPXTRCT
005800 CONFIGURATION SECTION.                                           AFPXTRCT
005900 SOURCE-COMPUTER. IBM-370.                                        AFPXTRCT
006000 OBJECT-COMPUTER. IBM-370.                                        AFPXTRCT
006100 INPUT-OUTPUT SECTION.                                            AFPXTRCT
006200 FILE-CONTROL.                                                    AFPXTRCT
006300     SELECT AFPCNTRL-FILE        ASSIGN TO AFPCNTRL,              AFPXTRCT
006400                                 FILE STATUS AFPCNTRL-STATUS.     AFPXTRCT
006500     SELECT AFPXTRCT-FILE        ASSIGN TO AFPXTRCT,              AFPXTRCT
006600                                 FILE STATUS AFPXTRCT-STATUS.     AFPXTRCT
006700     SELECT AFPINDEX-FILE        ASSIGN TO AFPINDEX,              AFPXTRCT
006800                                 FILE STATUS AFPINDEX-STATUS.     AFPXTRCT
006900     SELECT AFPPAGIN-FILE        ASSIGN TO AFPPAGIN,              AFPXTRCT
007000                                 ORGANIZATION RELATIVE,           AFPXTRCT
007100                                 ACCESS MODE DYNAMIC,             AFPXTRCT
007200                                 FILE STATUS AFPPAGIN-STATUS      AFPXTRCT
007300                                             VSAM-STATUS,         AFPXTRCT
007400                                 RELATIVE KEY AFPPAGIN-REC.       AFPXTRCT
007500     SELECT AFPKEY-FILE          ASSIGN TO AFPKEY,                AFPXTRCT
007600                                 ORGANIZATION INDEXED,            AFPXTRCT
007700                                 ACCESS MODE DYNAMIC,             AFPXTRCT
007800                                 FILE STATUS AFPKEY-STATUS        AFPXTRCT
007900                                             VSAM-STATUS,         AFPXTRCT
008000                                 RECORD KEY KEY-KEY.              AFPXTRCT
008100   SKIP2                                                          AFPXTRCT
008200 DATA DIVISION.                                                   AFPXTRCT
008300 FILE SECTION.                                                    AFPXTRCT
008400 FD  AFPCNTRL-FILE,                                               AFPXTRCT
008500     BLOCK CONTAINS 0 RECORDS,                                    AFPXTRCT
008600     LABEL RECORDS STANDARD,                                      AFPXTRCT
008700     RECORDING MODE F.                                            AFPXTRCT
008800 01  AFPCNTRL-RECORD.                                             AFPXTRCT
008900     05  AFPCNTRL-KEY        PIC X(80).                           AFPXTRCT
009000     EJECT                                                        AFPXTRCT
009100 FD  AFPXTRCT-FILE,                                               AFPXTRCT
009200     BLOCK CONTAINS 0 RECORDS,                                    AFPXTRCT
009300     LABEL RECORDS STANDARD,                                      AFPXTRCT
009400     RECORD VARYING 9  TO 32752 DEPENDING ON AFPXTRCT-LENGTH,     AFPXTRCT
009500     RECORDING MODE V.                                            AFPXTRCT
009600 01  AFPXTRCT-RECORD.                                             AFPXTRCT
009700     05  AFPXTRCT-INTRODUCER.                                     AFPXTRCT
009800       10  AFPXTRCT-CC       PIC X.                               AFPXTRCT
009900       10  AFPXTRCT-LEN-CHR  PIC XX.                              AFPXTRCT
010000       10  AFPXTRCT-RECLEN   REDEFINES AFPXTRCT-LEN-CHR           AFPXTRCT
010100                             PIC 9(4) BINARY.                     AFPXTRCT
010200* NOTE:  9(4) BINARY is used to get halfword integer, but COBOL   AFPXTRCT
010300* may restrict value to 9999. COBOL II compile-time parm          AFPXTRCT
010400* TRUNC(BIN) or TRUNC(OPT) will treat the value as a halfword     AFPXTRCT
010500* with no truncation (TRUNC(OPT) produces far better code).       AFPXTRCT
010600       10  AFPXTRCT-TYPE     PIC XXX.                             AFPXTRCT
010700       10  AFPXTRCT-FLAG     PIC X.                               AFPXTRCT
010800       10  AFPXTRCT-SEQ-CHR  PIC XX.                              AFPXTRCT
010900       10  AFPXTRCT-SEQNUM   REDEFINES AFPXTRCT-SEQ-CHR           AFPXTRCT
011000                             PIC 9(4) BINARY.                     AFPXTRCT
011100     05  AFPXTRCT-DATA.                                           AFPXTRCT
011200         10  AFPXTRCT-ARRAY      OCCURS 0 TO 32743,               AFPXTRCT
011300                                 DEPENDING ON AFPXTRCT-RECLEN,    AFPXTRCT
011400                                 INDEXED BY AFPXTRCT-INDX,        AFPXTRCT
011500                                 PIC X.                           AFPXTRCT
011600     EJECT                                                        AFPXTRCT
011700 FD  AFPINDEX-FILE,                                               AFPXTRCT
011800     BLOCK CONTAINS 0 RECORDS,                                    AFPXTRCT
011900     RECORD VARYING 10 TO 8201 DEPENDING ON AFPINDEX-LENGTH,      AFPXTRCT
012000     RECORDING MODE V.                                            AFPXTRCT
012100 01  AFPINDEX-RECORD.                                             AFPXTRCT
012200     05  AFPINDEX-INTRODUCER.                                     AFPXTRCT
012300       10  AFPINDEX-CC       PIC X.                               AFPXTRCT
012400       10  AFPINDEX-LEN-CHR  PIC XX.                              AFPXTRCT
012500       10  AFPINDEX-RECLEN   REDEFINES AFPINDEX-LEN-CHR           AFPXTRCT
012600                             PIC 9(4) BINARY.                     AFPXTRCT
012700       10  AFPINDEX-TYPE     PIC XXX.                             AFPXTRCT
012800       10  AFPINDEX-FLAG     PIC X.                               AFPXTRCT
012900       10  AFPINDEX-SEQ-CHR  PIC XX.                              AFPXTRCT
013000       10  AFPINDEX-SEQNUM   REDEFINES AFPINDEX-SEQ-CHR           AFPXTRCT
013100                             PIC 9(4) BINARY.                     AFPXTRCT
013200     05  AFPINDEX-DATA.                                           AFPXTRCT
013300         10  AFPINDEX-ARRAY      OCCURS 8192,                     AFPXTRCT
013400                                 DEPENDING ON AFPINDEX-RECLEN,    AFPXTRCT
013500                                 INDEXED BY AFPINDEX-INDX,        AFPXTRCT
013600                                 PIC X.                           AFPXTRCT
013700     EJECT                                                        AFPXTRCT
013800 FD  AFPPAGIN-FILE,                                               AFPXTRCT
013900     RECORD VARYING DEPENDING ON AFPPAGIN-LENGTH.                 AFPXTRCT
014000 01  AFPPAGIN-RECORD.                                             AFPXTRCT
014100     05  AFPPAGIN-INTRODUCER.                                     AFPXTRCT
014200       10  AFPPAGIN-CC       PIC X.                               AFPXTRCT
014300       10  AFPPAGIN-LEN-CHR  PIC XX.                              AFPXTRCT
014400       10  AFPPAGIN-RECLEN   REDEFINES AFPPAGIN-LEN-CHR           AFPXTRCT
014500                             PIC 9(4) BINARY.                     AFPXTRCT
014600       10  AFPPAGIN-TYPE     PIC XXX.                             AFPXTRCT
014700       10  AFPPAGIN-FLAG     PIC X.                               AFPXTRCT
014800       10  AFPPAGIN-SEQ-CHR  PIC XX.                              AFPXTRCT
014900       10  AFPPAGIN-SEQNUM   REDEFINES AFPPAGIN-SEQ-CHR           AFPXTRCT
015000                             PIC 9(4) BINARY.                     AFPXTRCT
015100     05  AFPPAGIN-DATA.                                           AFPXTRCT
015200         10  AFPPAGIN-ARRAY      OCCURS 0 TO 16375,               AFPXTRCT
015300                                 DEPENDING ON AFPPAGIN-RECLEN,    AFPXTRCT
015400                                 INDEXED BY AFPPAGIN-INDX,        AFPXTRCT
015500                                 PIC X.                           AFPXTRCT
015600     EJECT                                                        AFPXTRCT
015700 FD  AFPKEY-FILE                 GLOBAL,                          AFPXTRCT
015800     RECORD VARYING DEPENDING ON AFPKEY-LENGTH.                   AFPXTRCT
015900     COPY AFPKEY.                                                 AFPXTRCT
016000     EJECT                                                        AFPXTRCT
016100 WORKING-STORAGE SECTION.                                         AFPXTRCT
016200 77  PGMNAME                 PIC X(8) VALUE 'AFPXTRCT'.           AFPXTRCT
016300 77  ABND-PGM                PIC X(8) VALUE 'ILBOABN0'.           AFPXTRCT
016400 77  ABEND-CODE              PIC 9(4) BINARY VALUE 12.            AFPXTRCT
016500 77  SF-CC                   PIC X    VALUE X'5A'.                AFPXTRCT
016600 77  TYPE-GROUP              PIC X    VALUE X'C7'.                AFPXTRCT
016700 77  TYPE-PAGE               PIC X    VALUE X'D7'.                AFPXTRCT
016800 77  STATUS-OK               PIC 99   VALUE 0.                    AFPXTRCT
016900 77  STATUS-EOF              PIC 99   VALUE 10.                   AFPXTRCT
017000 77  AFPCNTRL-STATUS         PIC 99.                              AFPXTRCT
017100 77  AFPXTRCT-STATUS         PIC 99.                              AFPXTRCT
017200 77  AFPINDEX-STATUS         PIC 99.                              AFPXTRCT
017300 77  AFPPAGIN-STATUS         PIC 99.                              AFPXTRCT
017400 77  AFPPAGIN-REC            PIC 9(8) BINARY.                     AFPXTRCT
017500 77  AFPKEY-STATUS           PIC 99.                              AFPXTRCT
017600 77  AFPKEY-LENGTH           PIC 9(8) BINARY VALUE 8205.          AFPXTRCT
017700 77  INDEX-QUALIFIER         PIC 9(8) BINARY VALUE ZERO.          AFPXTRCT
017800 77  PAGE-GROUP              PIC X    VALUE 'G'.                  AFPXTRCT
017900 77  PAGE-PAGE               PIC X    VALUE 'P'.                  AFPXTRCT
018000 77  KEY-LEFT                PIC 9(4) BINARY.                     AFPXTRCT
018100 77  KEY-MAX                 PIC 9(4) BINARY VALUE 255.           AFPXTRCT
018200 77  KEY-PTR                 PIC 9(4) BINARY.                     AFPXTRCT
018300 77  IEL-PENDING-FLAG        PIC X    VALUE LOW-VALUE.            AFPXTRCT
018400     88  IEL-PENDING         VALUE HIGH-VALUE.                    AFPXTRCT
018500 77  AFPPAGIN-EOF-FLAG       PIC X    VALUE LOW-VALUE.            AFPXTRCT
018600     88  AFPPAGIN-EOF        VALUE HIGH-VALUE.                    AFPXTRCT
018700 77  AFPPAGIN-ERROR-FLAG     PIC X    VALUE LOW-VALUE.            AFPXTRCT
018800     88  AFPPAGIN-ERROR      VALUE HIGH-VALUE.                    AFPXTRCT
018900 77  AFPXTRCT-ERROR-FLAG     PIC X    VALUE LOW-VALUE.            AFPXTRCT
019000     88  AFPXTRCT-ERROR      VALUE HIGH-VALUE.                    AFPXTRCT
019100 77  AFPINDEX-ERROR-FLAG     PIC X    VALUE LOW-VALUE.            AFPXTRCT
019200     88  AFPINDEX-ERROR      VALUE HIGH-VALUE.                    AFPXTRCT
019300 77  AFPCNTRL-EOF-FLAG       PIC X    VALUE LOW-VALUE.            AFPXTRCT
019400     88  AFPCNTRL-EOF        VALUE HIGH-VALUE.                    AFPXTRCT
019500 77  FILE-OPEN-FLAG          PIC X    VALUE LOW-VALUE.            AFPXTRCT
019600     88  OPEN-ERROR          VALUE HIGH-VALUE.                    AFPXTRCT
019700 77  FILE-ERROR-FLAG         PIC X    VALUE LOW-VALUE.            AFPXTRCT
019800     88  FILE-ERROR          VALUE HIGH-VALUE.                    AFPXTRCT
019900 77  INDEX-FLAG              PIC X    VALUE LOW-VALUE.            AFPXTRCT
020000     88  NO-MORE-INDEX       VALUE HIGH-VALUE.                    AFPXTRCT
020100     SKIP1                                                        AFPXTRCT
020200 01  AFPXTRCT-LENGTH         PIC 9(8) BINARY.                     AFPXTRCT
020300 01  AFPPAGIN-LENGTH         PIC 9(8) BINARY.                     AFPXTRCT
020400 01  AFPINDEX-LENGTH         PIC 9(8) BINARY.                     AFPXTRCT
020500 01  AFPCNTRL-KEYLEN         PIC 9(8) BINARY.                     AFPXTRCT
020600 01  NEW-INDEX-COUNTERS.                                          AFPXTRCT
020700   05  NEW-BDT-SIZE          PIC 9(8) BINARY VALUE 0.             AFPXTRCT
020800   05  NEW-BNG-SIZE          PIC 9(8) BINARY VALUE 0.             AFPXTRCT
020900   05  NEW-BPG-SIZE          PIC 9(8) BINARY VALUE 0.             AFPXTRCT
021000 01  AFP-BDT                 PIC X(256).                          AFPXTRCT
021100     SKIP1                                                        AFPXTRCT
021200 01  VSAM-STATUS.                                                 AFPXTRCT
021300     05  VSAM-RC             PIC 9(4) BINARY.                     AFPXTRCT
021400     05  VSAM-FCT-CODE       PIC 9(1) BINARY.                     AFPXTRCT
021500     05  VSAM-FDBK-CODE      PIC 9(3) BINARY.                     AFPXTRCT
021600     SKIP1                                                        AFPXTRCT
021700 01  DATE-DATA.                                                   AFPXTRCT
021800   05  RUN-DATE.                                                  AFPXTRCT
021900     10 RUN-YY                 PIC 99.                            AFPXTRCT
022000     10 RUN-MM                 PIC 99.                            AFPXTRCT
022100     10 RUN-DD                 PIC 99.                            AFPXTRCT
022200   05  COMPILE-DATE.                                              AFPXTRCT
022300     10  COMP-DATE             PIC X(8).                          AFPXTRCT
022400     10  COMP-TIME             PIC X(12).                         AFPXTRCT
022500   05  RUN-TIME.                                                  AFPXTRCT
022600     10  RUN-HH                PIC 99.                            AFPXTRCT
022700     10  RUN-MM                PIC 99.                            AFPXTRCT
022800     10  RUN-SS                PIC 99.                            AFPXTRCT
022900     10  RUN-MS                PIC 99.                            AFPXTRCT
023000     SKIP2                                                        AFPXTRCT
023100 01  BINARY-NUMBERS.                                              AFPXTRCT
023200     05  BIN-4                   PIC 9(8) BINARY VALUE ZERO.      AFPXTRCT
023300     05  BIN4-X                  REDEFINES BIN-4                  AFPXTRCT
023400                                 PIC X(4).                        AFPXTRCT
023500     05  BIN2                    PIC 9(4) BINARY VALUE ZERO.      AFPXTRCT
023600     05  BIN2-X                  REDEFINES BIN2.                  AFPXTRCT
023700         10  FILLER              PIC X.                           AFPXTRCT
023800         10  BIN2-2              PIC X.                           AFPXTRCT
023900     SKIP2                                                        AFPXTRCT
024000 01  PAGE-DATA.                                                   AFPXTRCT
024100     05  PAGE-REC-STATS.                                          AFPXTRCT
024200         10  PAGE-RECORD-OFFSET  PIC 9(8) BINARY.                 AFPXTRCT
024300         10  PAGE-RECORD-EXTENT  PIC 9(8) BINARY.                 AFPXTRCT
024400         10  PAGE-BYTE-OFFSET    PIC 9(8) BINARY.                 AFPXTRCT
024500         10  PAGE-BYTE-EXTENT    PIC 9(8) BINARY.                 AFPXTRCT
024600     SKIP2                                                        AFPXTRCT
024700 01  TRIPLET-DATA.                                                AFPXTRCT
024800     05  TRIPLET-PTR             PIC 9(8) BINARY.                 AFPXTRCT
024900     05  TRIPLET-LENGTH          PIC 9(4) BINARY.                 AFPXTRCT
025000* offset to start of attribute value                              AFPXTRCT
025100     05  ATTVAL-OFFSET           PIC 9(8) BINARY VALUE 4.         AFPXTRCT
025200*  STRUCTURED FIELD DEFINITIONS'.                                 AFPXTRCT
025300     COPY STRFLDS SUPPRESS.                                       AFPXTRCT
025400 TITLE 'INITIALIZATION AND MAIN LINE'.                            AFPXTRCT
025500 PROCEDURE DIVISION.                                              AFPXTRCT
025600* Method of Operation:                                            AFPXTRCT
025700* A control card is read,  and a start issued on the keyed        AFPXTRCT
025800* file for the requested value. The key file record is then read. AFPXTRCT
025900******* IEL's not currently Implemented !!!!! ******************* AFPXTRCT
026000*  An IEL record is constructed from the key record. The          AFPXTRCT
026100* start extents are the next values for the document output file, AFPXTRCT
026200* ending extents are the next values plus the ending extents in   AFPXTRCT
026300* the key record. The IEL is written, followed by TLEs constructedAFPXTRCT
026400* from the key record.                                            AFPXTRCT
026500******* IEL's not currently Implemented !!!!! ******************  AFPXTRCT
026600*                                                                 AFPXTRCT
026700* The document file is then read, using the key start structured  AFPXTRCT
026800* field number, until the ending number is reached. For each BPG  AFPXTRCT
026900* in the document, a page IEL is built, and at EPG it is written  AFPXTRCT
027000* with the appropriate extent values and page names.              AFPXTRCT
027100* Document structured fields are written as read.                 AFPXTRCT
027200*                                                                 AFPXTRCT
027300* When all pages for the current key record have been written,    AFPXTRCT
027400* the next key record is read. If it is within the key range      AFPXTRCT
027500* selected, it is processed as above, otherwise the next control  AFPXTRCT
027600* card is read.                                                   AFPXTRCT
027700*                                                                 AFPXTRCT
027800                                                           EJECT  AFPXTRCT
027900 000-MAINLINE.                                                    AFPXTRCT
028000     PERFORM 0900-INITIALIZE.                                     AFPXTRCT
028100     IF OPEN-ERROR THEN                                           AFPXTRCT
028200       GOBACK.                                                    AFPXTRCT
028300                                                            SKIP1 AFPXTRCT
028400     PERFORM 1000-READ-AFPCNTRL.                                  AFPXTRCT
028500                                                            SKIP1 AFPXTRCT
028600     PERFORM 1100-WRITE-BDT.                                      AFPXTRCT
028700                                                            SKIP1 AFPXTRCT
028800     PERFORM UNTIL AFPCNTRL-EOF OR FILE-ERROR;                    AFPXTRCT
028900       MOVE LOW-VALUES TO INDEX-FLAG;                             AFPXTRCT
029000       PERFORM 2000-START-KEY;                                    AFPXTRCT
029100                                                            SKIP1 AFPXTRCT
029200       PERFORM UNTIL NO-MORE-INDEX;                               AFPXTRCT
029300                                                            SKIP1 AFPXTRCT
029400         PERFORM 2600-POSITION-ESDS;                              AFPXTRCT
029500                                                            SKIP1 AFPXTRCT
029600         PERFORM 2700-READ-N-WRITE-NEXT-GROUP;                    AFPXTRCT
029700                                                            SKIP1 AFPXTRCT
029800*        PERFORM WRITE-NEW-INDEX USING KEY-INDEX-REC;             AFPXTRCT
029900         PERFORM 2100-GET-NEXT-GROUP-INDEX;                       AFPXTRCT
030000                                                            SKIP1 AFPXTRCT
030100       END-PERFORM;                                               AFPXTRCT
030200                                                            SKIP1 AFPXTRCT
030300       PERFORM 1000-READ-AFPCNTRL;                                AFPXTRCT
030400                                                            SKIP1 AFPXTRCT
030500     END-PERFORM.                                                 AFPXTRCT
030600                                                            SKIP1 AFPXTRCT
030700     PERFORM 1110-WRITE-EDT.                                      AFPXTRCT
030800                                                            SKIP1 AFPXTRCT
030900     GOBACK.                                                      AFPXTRCT
031000 TITLE 'INTIAL STARTUP, OPEN FILES ET AL'                         AFPXTRCT
031100 0900-INITIALIZE.                                                 AFPXTRCT
031200     MOVE WHEN-COMPILED TO COMPILE-DATE.                          AFPXTRCT
031300     ACCEPT RUN-DATE FROM DATE.                                   AFPXTRCT
031400     ACCEPT RUN-TIME FROM TIME.                                   AFPXTRCT
031500     OPEN INPUT  AFPPAGIN-FILE,                                   AFPXTRCT
031600                 AFPCNTRL-FILE,                                   AFPXTRCT
031700                 AFPKEY-FILE,                                     AFPXTRCT
031800          OUTPUT AFPXTRCT-FILE,                                   AFPXTRCT
031900                 AFPINDEX-FILE.                                   AFPXTRCT
032000     IF AFPPAGIN-STATUS NOT EQUAL STATUS-OK THEN                  AFPXTRCT
032100       MOVE HIGH-VALUES TO AFPPAGIN-ERROR-FLAG;                   AFPXTRCT
032200       MOVE HIGH-VALUES TO FILE-OPEN-FLAG;                        AFPXTRCT
032300       DISPLAY 'ERROR OPENING AFPPAGIN INPUT FILE STATUS: '       AFPXTRCT
032400       AFPPAGIN-STATUS;                                           AFPXTRCT
032500       DISPLAY 'VSAM RC   : ' VSAM-RC;                            AFPXTRCT
032600       DISPLAY '  FCN CODE: ' VSAM-FCT-CODE;                      AFPXTRCT
032700       DISPLAY '  FEEDBACK: ' VSAM-FDBK-CODE;                     AFPXTRCT
032800       DISPLAY ' ';                                               AFPXTRCT
032900       MOVE VSAM-RC TO RETURN-CODE;                               AFPXTRCT
033000     ELSE                                                         AFPXTRCT
033100* Read the first record so we can save the BDT.                   AFPXTRCT
033200* Cross-reference FQN's will be wrong, but may be helpful in      AFPXTRCT
033300* problem tracking.                                               AFPXTRCT
033400* This would also allow easier use of orginal index records       AFPXTRCT
033500       PERFORM 9100-READ-AFPPAGIN-RECORD;                         AFPXTRCT
033600       MOVE AFPPAGIN-RECORD TO AFP-BDT;                           AFPXTRCT
033700     END-IF.                                                      AFPXTRCT
033800     IF AFPCNTRL-STATUS NOT EQUAL STATUS-OK THEN                  AFPXTRCT
033900       MOVE HIGH-VALUES TO FILE-OPEN-FLAG;                        AFPXTRCT
034000       DISPLAY 'ERROR OPENING AFPCNTRL INPUT FILE STATUS: '       AFPXTRCT
034100       AFPCNTRL-STATUS;                                           AFPXTRCT
034200       DISPLAY ' ';                                               AFPXTRCT
034300       MOVE AFPCNTRL-STATUS TO RETURN-CODE;                       AFPXTRCT
034400     END-IF.                                                      AFPXTRCT
034500     IF AFPKEY-STATUS NOT EQUAL STATUS-OK THEN                    AFPXTRCT
034600       MOVE HIGH-VALUES TO FILE-OPEN-FLAG;                        AFPXTRCT
034700       DISPLAY 'ERROR OPENING AFPKEY INPUT FILE STATUS: '         AFPXTRCT
034800       AFPKEY-STATUS;                                             AFPXTRCT
034900       DISPLAY 'VSAM RC   : ' VSAM-RC;                            AFPXTRCT
035000       DISPLAY '  FCN CODE: ' VSAM-FCT-CODE;                      AFPXTRCT
035100       DISPLAY '  FEEDBACK: ' VSAM-FDBK-CODE;                     AFPXTRCT
035200       DISPLAY ' ';                                               AFPXTRCT
035300       MOVE AFPKEY-STATUS TO RETURN-CODE;                         AFPXTRCT
035400     END-IF.                                                      AFPXTRCT
035500     IF AFPXTRCT-STATUS NOT EQUAL STATUS-OK THEN                  AFPXTRCT
035600       MOVE HIGH-VALUES TO FILE-OPEN-FLAG;                        AFPXTRCT
035700       DISPLAY 'ERROR OPENING AFPXTRCT OUTPUT FILE STATUS: '      AFPXTRCT
035800       AFPXTRCT-STATUS;                                           AFPXTRCT
035900       DISPLAY ' ';                                               AFPXTRCT
036000       MOVE AFPXTRCT-STATUS TO RETURN-CODE;                       AFPXTRCT
036100     END-IF.                                                      AFPXTRCT
036200     IF AFPINDEX-STATUS NOT EQUAL STATUS-OK THEN                  AFPXTRCT
036300       MOVE HIGH-VALUES TO FILE-OPEN-FLAG;                        AFPXTRCT
036400       DISPLAY 'ERROR OPENING AFPINDEX OUTPUT FILE STATUS: '      AFPXTRCT
036500       AFPINDEX-STATUS;                                           AFPXTRCT
036600       MOVE AFPINDEX-STATUS TO RETURN-CODE;                       AFPXTRCT
036700       DISPLAY ' ';                                               AFPXTRCT
036800     END-IF.                                                      AFPXTRCT
036900 TITLE 'FILE I/O ROUTINES'.                                       AFPXTRCT
037000 1000-READ-AFPCNTRL.                                              AFPXTRCT
037100     READ AFPCNTRL-FILE,                                          AFPXTRCT
037200       END-READ;                                                  AFPXTRCT
037300     IF AFPCNTRL-STATUS NOT EQUAL STATUS-OK THEN                  AFPXTRCT
037400       MOVE HIGH-VALUES TO AFPCNTRL-EOF-FLAG;                     AFPXTRCT
037500       IF AFPCNTRL-STATUS NOT EQUAL STATUS-EOF THEN               AFPXTRCT
037600         DISPLAY 'ERROR READING AFPCNTRL FILE - STATUS: '         AFPXTRCT
037700                 AFPCNTRL-STATUS;                                 AFPXTRCT
037800         MOVE AFPCNTRL-STATUS TO RETURN-CODE;                     AFPXTRCT
037900       END-IF;                                                    AFPXTRCT
038000     ELSE                                                         AFPXTRCT
038100       MOVE LOW-VALUES   TO KEY-KEY;                              AFPXTRCT
038200       MOVE AFPCNTRL-KEY TO KEY-KEY-VALUES(1:LENGTH AFPCNTRL-KEY);AFPXTRCT
038300       MOVE TYPE-GROUP   TO KEY-KEY-TYPE;                         AFPXTRCT
038400       PERFORM VARYING AFPCNTRL-KEYLEN FROM LENGTH AFPCNTRL-RECORDAFPXTRCT
038500         BY -1 UNTIL                                              AFPXTRCT
038600         AFPCNTRL-RECORD(AFPCNTRL-KEYLEN:1) NOT EQUAL SPACE;      AFPXTRCT
038700       END-PERFORM;                                               AFPXTRCT
038800     END-IF.                                                      AFPXTRCT
038900 TITLE 'WRITE BDT AND EDTS FOR NEW DOCUMENT'                      AFPXTRCT
039000 1100-WRITE-BDT.                                                  AFPXTRCT
039100*SHOULD USE ORIGINAL BDT TO PRESERVE LENGTHS IN INDICES           AFPXTRCT
039200     MOVE AFP-BDT TO AFPPAGIN-RECORD.                             AFPXTRCT
039300*SHOULD USE ORIGINAL BDT TO PRESERVE LENGTHS IN INDICES           AFPXTRCT
039400     ADD 1 AFPPAGIN-RECLEN GIVING AFPPAGIN-LENGTH.                AFPXTRCT
039500     PERFORM 9000-WRITE-AFPXTRCT-REC.                             AFPXTRCT
039600                                                          SKIP1   AFPXTRCT
039700 1110-WRITE-EDT.                                                  AFPXTRCT
039800     MOVE LOW-VALUES  TO AFPXTRCT-RECORD.                         AFPXTRCT
039900     MOVE SF-EDT      TO AFPPAGIN-TYPE.                           AFPXTRCT
040000     MOVE SF-CC       TO AFPPAGIN-CC.                             AFPXTRCT
040100     MOVE HIGH-VALUES TO AFPPAGIN-DATA(1:8).                      AFPXTRCT
040200     MOVE 16          TO AFPPAGIN-RECLEN.                         AFPXTRCT
040300     ADD 1 AFPPAGIN-RECLEN GIVING AFPPAGIN-LENGTH.                AFPXTRCT
040400     PERFORM 9000-WRITE-AFPXTRCT-REC.                             AFPXTRCT
040500                                                         SKIP1    AFPXTRCT
040600 TITLE 'START AND READ THE REQUESTED INDEX FILE RECORDS'          AFPXTRCT
040700 2000-START-KEY.                                                  AFPXTRCT
040800     START AFPKEY-FILE KEY GREATER OR EQUAL KEY-KEY-VALUES,       AFPXTRCT
040900     END-START.                                                   AFPXTRCT
041000     IF AFPKEY-STATUS NOT EQUAL STATUS-OK THEN                    AFPXTRCT
041100*      MOVE HIGH-VALUES TO AFPKEY-ERROR-FLAG,                     AFPXTRCT
041200       DISPLAY 'ERROR STARTING AFPKEY FILE - STATUS: '            AFPXTRCT
041300                 AFPKEY-STATUS;                                   AFPXTRCT
041400       DISPLAY 'VSAM RC   : ' VSAM-RC;                            AFPXTRCT
041500       DISPLAY '  FCN CODE: ' VSAM-FCT-CODE;                      AFPXTRCT
041600       DISPLAY '  FEEDBACK: ' VSAM-FDBK-CODE;                     AFPXTRCT
041700       DISPLAY ' ';                                               AFPXTRCT
041800       MOVE AFPKEY-STATUS TO RETURN-CODE;                         AFPXTRCT
041900     END-IF.                                                      AFPXTRCT
042000*      INVALID KEY                                                AFPXTRCT
042100*        MOVE HIGH-VALUE TO NO-MORE-INDEX;                        AFPXTRCT
042200*      NOT INVALID KEY                                            AFPXTRCT
042300*        MOVE LOW-VALUE TO NO-MORE-INDEX;                         AFPXTRCT
042400                                                         SKIP1    AFPXTRCT
042500     PERFORM 2100-GET-NEXT-GROUP-INDEX.                           AFPXTRCT
042600                                                         SKIP1    AFPXTRCT
042700 2100-GET-NEXT-GROUP-INDEX.                                       AFPXTRCT
042800                                                         SKIP1    AFPXTRCT
042900     PERFORM 9200-GET-NEXT-INDEX                                  AFPXTRCT
043000         WITH TEST AFTER                                          AFPXTRCT
043100         UNTIL KEY-KEY-TYPE EQUAL TYPE-GROUP.                     AFPXTRCT
043200                                                         SKIP1    AFPXTRCT
043300     IF AFPCNTRL-KEY(1:AFPCNTRL-KEYLEN) NOT EQUAL                 AFPXTRCT
043400        KEY-KEY-VALUES(1:AFPCNTRL-KEYLEN) THEN                    AFPXTRCT
043500       MOVE HIGH-VALUES TO INDEX-FLAG;                            AFPXTRCT
043600     END-IF.                                                      AFPXTRCT
043700                                                         SKIP1    AFPXTRCT
043800                                                         SKIP1    AFPXTRCT
043900 2600-POSITION-ESDS.                                              AFPXTRCT
044000     MOVE LOW-VALUES TO AFPPAGIN-RECORD.                          AFPXTRCT
044100     ADD  KEY-REC-OFFSET 1 GIVING AFPPAGIN-REC.                   AFPXTRCT
044200     START AFPPAGIN-FILE;                                         AFPXTRCT
044300     END-START.                                                   AFPXTRCT
044400     IF AFPPAGIN-STATUS NOT EQUAL STATUS-OK THEN                  AFPXTRCT
044500       MOVE HIGH-VALUES TO AFPPAGIN-ERROR-FLAG,                   AFPXTRCT
044600       DISPLAY 'ERROR STARTING AFPPAGIN FILE - STATUS: '          AFPXTRCT
044700                 AFPPAGIN-STATUS;                                 AFPXTRCT
044800       DISPLAY 'VSAM RC   : ' VSAM-RC;                            AFPXTRCT
044900       DISPLAY '  FCN CODE: ' VSAM-FCT-CODE;                      AFPXTRCT
045000       DISPLAY '  FEEDBACK: ' VSAM-FDBK-CODE;                     AFPXTRCT
045100       DISPLAY ' ';                                               AFPXTRCT
045200       MOVE AFPPAGIN-STATUS TO RETURN-CODE;                       AFPXTRCT
045300     END-IF.                                                      AFPXTRCT
045400 TITLE 'INDEX FILE READ AND WRITE'.                               AFPXTRCT
045500 2700-READ-N-WRITE-NEXT-GROUP.                                    AFPXTRCT
045600     PERFORM UNTIL AFPPAGIN-TYPE = SF-ENG;                        AFPXTRCT
045700       PERFORM 9100-READ-AFPPAGIN-RECORD;                         AFPXTRCT
045800       PERFORM 9000-WRITE-AFPXTRCT-REC;                           AFPXTRCT
045900     END-PERFORM.                                                 AFPXTRCT
046000 TITLE 'WRITE AFP EXTRACTED RECORDS'                              AFPXTRCT
046100 9000-WRITE-AFPXTRCT-REC.                                         AFPXTRCT
046200     MOVE AFPPAGIN-LENGTH TO AFPXTRCT-LENGTH.                     AFPXTRCT
046300     WRITE AFPXTRCT-RECORD FROM AFPPAGIN-RECORD.                  AFPXTRCT
046400     IF AFPXTRCT-STATUS NOT EQUAL STATUS-OK THEN                  AFPXTRCT
046500       MOVE HIGH-VALUES TO FILE-ERROR-FLAG;                       AFPXTRCT
046600       DISPLAY 'ERROR WRITING AFPXTRCT FILE - STATUS: '           AFPXTRCT
046700                 AFPXTRCT-STATUS;                                 AFPXTRCT
046800       DISPLAY 'TRYING TO WRITE RECORD OF LENGTH '                AFPXTRCT
046900       AFPXTRCT-LENGTH;                                           AFPXTRCT
047000       DISPLAY ' ';                                               AFPXTRCT
047100       MOVE AFPXTRCT-STATUS TO RETURN-CODE;                       AFPXTRCT
047200     ELSE                                                         AFPXTRCT
047300       ADD AFPXTRCT-LENGTH TO NEW-BDT-SIZE;                       AFPXTRCT
047400     END-IF.                                                      AFPXTRCT
047500 TITLE 'WRITE AFP EXTRACTED RECORDS'                              AFPXTRCT
047600 9100-READ-AFPPAGIN-RECORD.                                       AFPXTRCT
047700     READ AFPPAGIN-FILE NEXT RECORD.                              AFPXTRCT
047800     IF AFPPAGIN-STATUS NOT EQUAL STATUS-OK THEN                  AFPXTRCT
047900       MOVE HIGH-VALUES TO AFPPAGIN-EOF-FLAG;                     AFPXTRCT
048000       IF AFPPAGIN-STATUS NOT EQUAL STATUS-EOF THEN               AFPXTRCT
048100         MOVE HIGH-VALUES TO FILE-ERROR-FLAG;                     AFPXTRCT
048200         DISPLAY 'ERROR READING AFPPAGIN FILE - STATUS: ';        AFPXTRCT
048300                 AFPPAGIN-STATUS;                                 AFPXTRCT
048400         DISPLAY 'VSAM RC   : ' VSAM-RC;                          AFPXTRCT
048500         DISPLAY '  FCN CODE: ' VSAM-FCT-CODE;                    AFPXTRCT
048600         DISPLAY '  FEEDBACK: ' VSAM-FDBK-CODE;                   AFPXTRCT
048700         DISPLAY ' ';                                             AFPXTRCT
048800         MOVE AFPPAGIN-STATUS TO RETURN-CODE;                     AFPXTRCT
048900       END-IF;                                                    AFPXTRCT
049000     END-IF.                                                      AFPXTRCT
049100 TITLE 'START AND READ THE REQUESTED INDEX FILE RECORD'           AFPXTRCT
049200 9200-GET-NEXT-INDEX.                                             AFPXTRCT
049300     READ AFPKEY-FILE NEXT RECORD.                                AFPXTRCT
049400     IF AFPKEY-STATUS NOT EQUAL STATUS-OK THEN                    AFPXTRCT
049500*      MOVE HIGH-VALUES TO AFPKEY-ERROR-FLAG,                     AFPXTRCT
049600       DISPLAY 'ERROR READING AFPKEY FILE - STATUS: '             AFPXTRCT
049700                 AFPKEY-STATUS;                                   AFPXTRCT
049800       DISPLAY 'VSAM RC   : ' VSAM-RC;                            AFPXTRCT
049900       DISPLAY '  FCN CODE: ' VSAM-FCT-CODE;                      AFPXTRCT
050000       DISPLAY '  FEEDBACK: ' VSAM-FDBK-CODE;                     AFPXTRCT
050100       DISPLAY ' ';                                               AFPXTRCT
050200       MOVE AFPKEY-STATUS TO RETURN-CODE;                         AFPXTRCT
050300     END-IF.                                                      AFPXTRCT
050400*      AT END MOVE HIGH-VALUE TO AFPKEY-EOF.                      AFPXTRCT
050500* At each begin page a new IEL for the page is begun with the     AFPXTRCT
050600* starting record number and byte offset of the BPG. At each      AFPXTRCT
050700* end page, the extent values are filled in and the IEL written.  AFPXTRCT
