//*===============================================================*     00000403
//KILL     EXEC PGM=IDCAMS,REGION=2M                                    00000503
//*===============================================================*     00000603
//* EMPTY OUTPUT FILE, DELETE ANY OTHERS CREATED                  *     00000703
//*===============================================================*     00000803
//SYSPRINT DD  SYSOUT=*                                                 00000903
//SYSIN    DD  *                                                        00001003
 DELETE <YOURHLQ>.ACIF.OUTPUT                                           00001103
 DELETE <YOURHLQ>.ACIF.INDEX                                            00001203
 DELETE <YOURHLQ>.ACIF.RESLIB                                           00001303
 SET MAXCC=0;                                                           00001603
//ACIF EXEC PGM=APKACIF,REGION=3M                                       00001704
//*===============================================================*     00001803
//* RUN ACIF, CREATING OUTPUT AND A RESOURCE LIBRARY AND INDEX    *     00001903
//*===============================================================*     00002003
//STEPLIB  DD  DSN=ACIF.APKACIF.SAPKMOD1,DISP=SHR                       00002203
//INPUT    DD  DSN=<YOURHLQ>.SAMPLE.DATA,DISP=SHR                       00002303
//SYSIN DD *                                                            00002903
 /* Linedata-MICR Payroll checks: indexed */                            00003003
 CC = YES                           /* carriage control used    */      00004003
 CCTYPE = A              /* carriage control type    */                 00004103
 CPGID = 500                 /* code page identifier     */             00004203
 FDEFLIB= SYS1.FDEFLIB                                                  00004303
 FIELD1 = 0,2,20               /* 1st field                 */          00004403
 FIELD2 = 0,21,21               /* 2nd field                 */         00004503
 FIELD3 = 0,42,18               /* 3rd field                 */         00004603
 FIELD4 = 0,52,2               /* 4th field                 */          00004703
 FIELD5 = 0,60,6               /* 5th field                 */          00004803
 FIELD6 = 0,73,11               /* 6th field                 */         00004903
 FIELD7 = 0,66,4               /* 7th field                 */          00005003
 FONTLIB= SYS1.FONTLIBB                                                 00005103
 FORMDEF  = F1RSPAYR            /* formdef name              */         00005203
 INDEX1 = 'Name',FIELD1               /* 1st INDEX                 */   00005303
 INDEX2 = 'Street',FIELD2               /* 2nd INDEX                 */ 00005403
 INDEX3 = 'City,State',FIELD3               /* 3rd INDEX                00005503
 INDEX5 = 'Zip',FIELD5,FIELD7               /* 5th INDEX                00005603
 INDEX6 = 'SSN',FIELD6               /* 6th INDEX                 */    00005703
 INDEXDD= INDEX         /* index file ddname         */                 00005803
 INDEXOBJ = ALL              /* index level group or page */            00005903
 INPUTDD= INPUT         /* input file ddname         */                 00006003
 OUTPUTDD = OUTPUT      /* output file ddname        */                 00006103
 OVLYLIB= SYS1.OVERLIB                                                  00006203
 PAGEDEF  = P1RSPAYR             /*  pagedef name             */        00006303
 PDEFLIB= SYS1.PDEFLIB                                                  00006403
 PSEGLIB= SYS1.PSEGLIB                                                  00006503
 RESFILE = SEQ          /* resource file type        */                 00006603
 RESOBJDD = RESOURCE    /* RESOURCE FILE DDNAME      */                 00006703
 RESTYPE  = ALL         /* resource type selection   */                 00006803
 TRIGGER1 = *,1,'1'            /* 1st TRIGGER               */          00006903
 USERLIB= <YOURHLQ>.SAMPLE.RESLIB                                       00007003
/*                                                                      00007103
//OUTPUT   DD DSN=<YOURHLQ>.ACIF.OUTPUT,DISP=(NEW,CATLG),               00007203
//         SPACE=(32760,(15,15),RLSE),UNIT=SYSDA,                       00007303
//         DCB=(LRECL=32756,BLKSIZE=32760,RECFM=VBM,DSORG=PS)           00007403
//INDEX    DD DSN=<YOURHLQ>.ACIF.INDEX,DISP=(NEW,CATLG),                00007503
//         SPACE=(32760,(15,15),RLSE),UNIT=SYSDA,                       00007603
//         DCB=(LRECL=32756,BLKSIZE=32760,RECFM=VB,DSORG=PS)            00007703
//RESOURCE DD DSN=<YOURHLQ>.ACIF.RESLIB,DISP=(NEW,CATLG),               00007803
//         SPACE=(32760,(15,15),RLSE),UNIT=SYSDA,                       00007903
//         DCB=(LRECL=32756,BLKSIZE=32760,RECFM=VBM,DSORG=PS)           00008003
//SYSPRINT DD  SYSOUT=*                                                 00008103
//SYSUDUMP DD  SYSOUT=*                                                 00008203
//DEFNNDX  EXEC PGM=IDCAMS,REGION=2M                                    00008303
//* define the index ksds and mo:dca data rrds files                    00008406
//SYSPRINT DD  SYSOUT=*                                                 00008500
//MODCADD  DD  DSN=*.ACIF.OUTPUT,DISP=SHR                               00008603
//SYSIN    DD  *                                                        00008700
 /* define the index file */                                            00008806
 DELETE <YOURHLQ>.AFPVSAM                                               00008903
 SET MAXCC = 0                                                          00009000
 DEFINE CL (NAME(<YOURHLQ>.AFPVSAM) RECORDS(100 50) -                   00009103
            IMBED INDEXED KEYS(255 0) RECORDSIZE(512 2048) -            00009200
            REPLICATE VOLUME(TEMP00) ) -                                00009300
            DATA(NAME(<YOURHLQ>.AFPVSAM.DATA) ) -                       00009403
            INDEX(NAME(<YOURHLQ>.AFPVSAM.INDEX) )                       00009503
 /* DEFINE THE DATA FILE AS RELATIVE RECORD */                          00009603
 DELETE <YOURHLQ>.AFPPAGIN.VSAM                                         00009703
 DELETE <YOURHLQ>.AFPXTRCT                                              00009803
 DELETE <YOURHLQ>.AFPINDEX                                              00009903
 SET MAXCC = 0                                                          00010003
 DEFINE CL (NAME(<YOURHLQ>.AFPPAGIN.VSAM) RECORDS(100 50) -             00010103
            IMBED RECORDSIZE(9 16384) -                                 00010206
            NUMD-                                                       00010303
            VOLUME(<VSAMVOL>) ) -                                       00010406
            DATA(NAME(<YOURHLQ>.AFPPAGIN.VSAM.DATA) )                   00010503
 /* copy the mo:dca data from acif into the rrds */                     00010606
 REPRO INFILE(MODCADD) ODS(<YOURHLQ>.AFPPAGIN.VSAM)                     00010703
// IF RC = 0 THEN                                                       00010800
//* THIS STEP CONVERTS THE FLAT MO:DCA INDEX FILE TO A VSAM KSDS        00010903
//AFPINDEX EXEC PGM=AFPINDEX,TIME=(,10)                                 00011002
//STEPLIB  DD  DSN=<YOURHLQ>.LOAD,DISP=SHR                              00020003
//         DD  DSN=COB2.V131.COB2LIB,DISP=SHR                           00030000
//SYSABOUT DD  SYSOUT=*                                                 00040000
//SYSDBOUT DD  SYSOUT=*                                                 00041000
//SYSOUT   DD  SYSOUT=*                                                 00050000
//SYSUDUMP DD  SYSOUT=*                                                 00060000
//DAFPINDA DD  DSN=<YOURHLQ>.ACIF.INDEX,DISP=SHR                        00070003
//DAFPINDB DD  DSN=<YOURHLQ>.AFPVSAM,DISP=SHR                           00080003
// IF AFPINDEX.RUN THEN                                                 00081000
//AFPXTRCT EXEC PGM=AFPXTRCT                                            00135003
//STEPLIB  DD  DSN=<YOURHLQ>.LOAD,DISP=SHR                              00136006
//         DD  DSN=COB2.V131.COB2LIB,DISP=SHR                           00137003
//SYSABOUT DD  SYSOUT=*                                                 00138003
//SYSDBOUT DD  SYSOUT=*                                                 00139003
//SYSOUT   DD  SYSOUT=*                                                 00139103
//SYSUDUMP DD  SYSOUT=*                                                 00139203
//AFPKEY   DD  DSN=<YOURHLQ>.AFPKEY,DISP=SHR                            00139303
//AFPPAGIN DD  DSN=<YOURHLQ>.AFPPAGIN.VSAM,DISP=SHR                     00139403
//AFPINDEX DD  DSN=<YOURHLQ>.AFPINDEX,DISP=(NEW,CATLG,CATLG),           00139503
//             DCB=(LRECL=8205,BLKSIZE=8209,RECFM=VBM,DSORG=PS),        00139603
//             SPACE=(TRK,(1,1)),UNIT=SYSDA                             00139703
//AFPXTRCT DD  DSN=<YOURHLQ>.AFPXTRCT,DISP=(NEW,CATLG,CATLG),           00139803
//             DCB=(LRECL=32756,BLKSIZE=32760,RECFM=VBM,DSORG=PS),      00139903
//             SPACE=(TRK,(1,1)),UNIT=SYSDA                             00140003
//* CONTROL CARDS TO SELECT GROUPS FROM THE RRDS.                       00140103
//AFPCNTRL DD  *                                                        00140203
PENELOPE F. ARCHIVE  123 FOURUP AVE      DUPLEXVILLE, CO   074910916325 00140303
GEORGE D. MARKUP     321 SCRIPT COURT    DOCUMENT, CO                   00140403
/*                                                                      00140503
// ENDIF                                                                00141000
// ENDIF                                                                00150000
