#######################################################################
##                                                                   ##
## Makefile : User Exit Makefile                                     ##
##                                                                   ##
## This file contains the build rules for the ACIF user exits.       ##
##                                                                   ##
## COPYRIGHT:                                                        ##
##  5765-140,20G0732 (C) COPYRIGHT IBM CORPORATION 1987,1993.        ##
##  All Rights Reserved                                              ##
##  Licensed Materials - Property of IBM                             ##
##                                                                   ##
##  US Government Users Restricted Rights - Use, duplication or      ##
##  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.##
##                                                                   ##
## NOTE: This program sample is provided on an as-is basis.          ##
##       The licensee of the PSF product is free to copy, revise,    ##
##       modify, and make derivative works of this program sample    ##
##       as they see fit.                                            ##
##                                                                   ##
## Warning: Be sure that the tab characters (x'05' in EBCDIC)        ##
##          are correctly translated to tabs (x'09' in ASCII)        ##
##          when downloading to AIX.  See $CC and rm lines.          ##
##                                                                   ##
## NOTE:                                                             ##
##                                                                   ##
## STATUS = RELEASE 1  LEVEL 0                                       ##
##                                                                   ##
## CHANGE ACTIVITY:                                                  ##
##                                                                   ##
## PROBNO  REL   DATE#AUTHOR DESCRIPTION                        FICHE##
## ------- ----- ----------- -----------                        -----##
##                                                                   ##
##                                                                   ##
#######################################################################

CC            = xlc

CDEBUGFLAGS   = -O

DEFINES       =

COMPATFLAGS   =

LOADFLAGS     = -lc -H512 -T512

CFLAGS        = $(CDEBUGFLAGS) $(DEFINES) $(COMPATFLAGS) $(LOADFLAGS)

TARGETS       = apkoutdb

all:    $(TARGETS)

apkoutdb: apkoutdb.c apkexits.h
		$(CC) $(CFLAGS) -o $@ apkoutdb.c -eOUTEXIT

clean:
		rm -f $(TARGETS)
