000100 PROCESS DYNAM NUMPROC(PFD) TRUNC(OPT) APOST LIB NOSEQ RES RENT   APKINPTS
000200* LAST UPDATE ON 9 Feb 1995 AT 08:01:22 BY  VEND789 VERSION 01   *APKINPTS
000300 ID DIVISION.                                                     APKINPTS
000400 PROGRAM-ID. APKINPTS.                                            APKINPTS
000500 AUTHOR. TURETZKY--HYDRA.                                         APKINPTS
000600 INSTALLATION. IBM BOULDER PROGRAMMING CENTER.                    APKINPTS
000700               NOTE: REQUIRES VS COBOL II.  This program is a     APKINPTS
000800               sample exit for ACIF (APKACIF,5648-062)            APKINPTS
000900               demonstrating the use of the ACIF input exit.      APKINPTS
001000                                                                  APKINPTS
001100               In order to use this exit, include the control     APKINPTS
001200               INPEXIT=APKINPTS to enable this exit, and include  APKINPTS
001300               the load module in a dataset referenced in STEPLIB APKINPTS
001400               or elsewhere in the module search order.           APKINPTS
001500                                                                  APKINPTS
001600               The program is used to test the input exit. It willAPKINPTS
001700               pass back each input record unchanged, then insert APKINPTS
001800               a record after each input record. It will also     APKINPTS
001900               insert a record after EOF.                         APKINPTS
002000                                                                  APKINPTS
002100               Method of operation: for each input record, the    APKINPTS
002200               request flag is set to INSERT (x'02'), the existingAPKINPTS
002300               record is sent back unchanged, then when control isAPKINPTS
002400               returned a new record created and the flag set to  APKINPTS
002500               process (x'00').                                   APKINPTS
002600                                                                  APKINPTS
002700               This program must either be compiled with the      APKINPTS
002800               NORENT option or linked with IGZOPT with the       APKINPTS
002900               RTEREUS option.  (See VS COBOL II Application      APKINPTS
003000               Programming Guide, SC26-4045).                     APKINPTS
003100                                                                  APKINPTS
003200 DATE-WRITTEN. 23 SEP 93.                                         APKINPTS
003300 DATE-COMPILED.                                                   APKINPTS
003400 SECURITY. IBM SAMPLE CODE ONLY.                                  APKINPTS
003500*/**************************************************************/ APKINPTS
003600*/*   (C) COPYRIGHT IBM CORPORATION, 1994                      */ APKINPTS
003700*/*                                                            */ APKINPTS
003800*/*        >>>>>>>  IMPORTANT NOTICE   <<<<<<<<<<<             */ APKINPTS
003900*/*                                                            */ APKINPTS
004000*/*   THIS PROGRAM IS NOT SUPPORTED IN ANY WAY BY IBM.  IT     */ APKINPTS
004100*/*   HAS NOT BEEN SUBJECTED TO ANY FORMAL IBM TESTING AND     */ APKINPTS
004200*/*   IS DISTRIBUTED ON AN "AS-IS" BASIS WITHOUT ANY           */ APKINPTS
004300*/*   WARRANTY EITHER EXPRESSED OR IMPLIED.  THE USE OF        */ APKINPTS
004400*/*   THIS CODE OR ANY INFORMATION OR TECHNIQUES IMPLICIT      */ APKINPTS
004500*/*   WITHIN IT IS THE SOLE RESPONSIBILITY OF THE CUSTOMER.    */ APKINPTS
004600*/*   SUCH USE DEPENDS UPON THE CUSTOMER'S ABILITY TO          */ APKINPTS
004700*/*   EVALUATE THE INFORMATION IN THE CONTEXT OF THEIR OWN     */ APKINPTS
004800*/*   PARTICULAR OPERATING ENVIRONMENT.  THIS CODE HAS         */ APKINPTS
004900*/*   OPERATED SUCCESSFULLY IN THE COMPUTING ENVIRONMENT AT    */ APKINPTS
005000*/*   THE BOULDER PROGRAMMING CENTER.  THERE IS NO             */ APKINPTS
005100*/*   GUARANTEE THAT IT WILL OPERATE CORRECTLY ELSEWHERE.      */ APKINPTS
005200*/**************************************************************/ APKINPTS
005300 TITLE 'ACIF Test Input Exit'.                                    APKINPTS
005400 ENVIRONMENT DIVISION.                                            APKINPTS
005500 CONFIGURATION SECTION.                                           APKINPTS
005600 SOURCE-COMPUTER. IBM-370.                                        APKINPTS
005700 OBJECT-COMPUTER. IBM-370.                                        APKINPTS
005800     EJECT                                                        APKINPTS
005900 DATA DIVISION.                                                   APKINPTS
006000 WORKING-STORAGE SECTION.                                         APKINPTS
006100 77  PGMNAME                 PIC X(8) VALUE 'APKINPTS'.           APKINPTS
006200 77  ABND-PGM                PIC X(8) VALUE 'ILBOABN0'.           APKINPTS
006300 77  ABEND-CODE              PIC 9(4) BINARY VALUE 12.            APKINPTS
006400 77  AFPWRITE                PIC X(8) VALUE 'AFPWRITE'.           APKINPTS
006500 77  PAGE-COUNT              PIC 9(8) BINARY VALUE ZERO.          APKINPTS
006600 77  LINE-COUNT              PIC 9(8) BINARY VALUE ZERO.          APKINPTS
006700 77  EOF-LIT                 PIC X(9) VALUE 'AFTER EOF'.          APKINPTS
006800 77  CC-TOF                  PIC X.                               APKINPTS
006900     88  ANSI-TOF            VALUE '1'.                           APKINPTS
007000     88  MACH-TOF            VALUE X'8B'.                         APKINPTS
007100 77  FIRST-LINE-FLAG         PIC X VALUE LOW-VALUE.               APKINPTS
007200     88  FIRST-LINE          VALUE HIGH-VALUE.                    APKINPTS
007300     88  NOTFIRST-LINE       VALUE LOW-VALUE.                     APKINPTS
007400     SKIP2                                                        APKINPTS
007500 01  NEW-LINE.                                                    APKINPTS
007600     05  NEW-CC              PIC X.                               APKINPTS
007700     05  FILLER              PIC X(17) VALUE '>>>INSERTED LINE '. APKINPTS
007800     05  NEW-COUNT           PIC ZZZ,ZZ9.                         APKINPTS
007900     05  FILLER              PIC X(03) VALUE '<<<'.               APKINPTS
008000     05  NEW-EOF             PIC X(9) VALUE SPACES.               APKINPTS
008100/ PASSED PARAMETERS.                                              APKINPTS
008200 LINKAGE SECTION.                                                 APKINPTS
008300 01  INP-PARMS.                                                   APKINPTS
008400     05  INP-USTOR           POINTER.                             APKINPTS
008500     05  INP-PFATTR          POINTER.                             APKINPTS
008600     05  INP-RECPTR          POINTER.                             APKINPTS
008700     05  FILLER              POINTER.                             APKINPTS
008800     05  INP-RECLEN          PIC 9(4) BINARY.                     APKINPTS
008900     05  FILLER              PIC XX.                              APKINPTS
009000     05  INP-REQUEST         PIC X.                               APKINPTS
009100         88  INP-USE         VALUE X'00'.                         APKINPTS
009200         88  INP-DELETE      VALUE X'01'.                         APKINPTS
009300         88  INP-INSERT      VALUE X'02'.                         APKINPTS
009400     05  INP-EOF-FLAG        PIC X.                               APKINPTS
009500         88  INP-EOF         VALUE 'Y'.                           APKINPTS
009600                                                                  APKINPTS
009700 01  INP-UAREA.                                                   APKINPTS
009800     05  UAREA-CNTR          PIC 9(4) BINARY.                     APKINPTS
009900     05  UAREA-INSCOUNT      PIC 9(4) BINARY.                     APKINPTS
010000     05  INSERT-FLAG         PIC X.                               APKINPTS
010100         88 INSERT-LINE      VALUE HIGH-VALUE.                    APKINPTS
010200         88 INSERT-MULTIPLE  VALUE 'M'.                           APKINPTS
010300         88 NOINSERT-LINE    VALUE LOW-VALUE.                     APKINPTS
010400     05  FILLER              PIC X(12).                           APKINPTS
010500                                                                  APKINPTS
010600 01  INP-ATTR.                                                    APKINPTS
010700     05  INP-CC              PIC XXX.                             APKINPTS
010800     05  INP-CCTYPE          PIC X.                               APKINPTS
010900         88  INP-ANSI-CC     VALUE 'A'.                           APKINPTS
011000         88  INP-MACH-CC     VALUE 'M'.                           APKINPTS
011100     05  INP-CHARS           PIC X(20).                           APKINPTS
011200     05  INP-FORMDEF         PIC X(8).                            APKINPTS
011300     05  INP-PAGEDEF         PIC X(8).                            APKINPTS
011400     05  INP-PRMODE          PIC X(8).                            APKINPTS
011500     05  INP-TRC             PIC XXX.                             APKINPTS
011600                                                                  APKINPTS
011700* This is a template for the input record, pointed to by          APKINPTS
011800* INP-RECPTR. The record's actual length is given by              APKINPTS
011900* INP-RECLEN.                                                     APKINPTS
012000 01  INP-LINE.                                                    APKINPTS
012100     05  INP-CCVAL           PIC X.                               APKINPTS
012200     05  INP-TRCVAL          PIC X.                               APKINPTS
012300     05  INP-PAGELIT         PIC X(4).                            APKINPTS
012400     05  FILLER              PIC X.                               APKINPTS
012500     05  INP-PAGENUM         PIC 9(4).                            APKINPTS
012600     05  FILLER              PIC X.                               APKINPTS
012700     05  INP-LINELIT         PIC X(4).                            APKINPTS
012800     05  FILLER              PIC X.                               APKINPTS
012900     05  INP-LINENUM         PIC 9(3).                            APKINPTS
013000     05  FILLER              PIC X(8191).                         APKINPTS
013100     SKIP1                                                        APKINPTS
013200 TITLE 'Initialization and Main Line'.                            APKINPTS
013300 PROCEDURE DIVISION USING INP-PARMS.                              APKINPTS
013400* make work area, attributes, and input line addressable.         APKINPTS
013500     SET ADDRESS OF INP-UAREA TO INP-USTOR.                       APKINPTS
013600     SET ADDRESS OF INP-ATTR TO INP-PFATTR.                       APKINPTS
013700     SET ADDRESS OF INP-LINE TO INP-RECPTR.                       APKINPTS
013800* no special action is necessary at EOF.                          APKINPTS
013900     IF INP-EOF                                                   APKINPTS
014000      THEN                                                        APKINPTS
014100       DISPLAY PGMNAME, ' EOF REACHED.';                          APKINPTS
014200       MOVE EOF-LIT TO NEW-EOF;                                   APKINPTS
014300       PERFORM 0100-INSERT-RECORD;                                APKINPTS
014400       GOBACK;                                                    APKINPTS
014500     END-IF.                                                      APKINPTS
014600* The print file attributes are used to determine the type        APKINPTS
014700* of carriage control to test for for top-of-form.                APKINPTS
014800* For purposes of this example, we assume the file will           APKINPTS
014900* always have carriage control, and if machine control the        APKINPTS
015000* skip to channel 1 immediate is used for new pages.              APKINPTS
015100     IF INP-ANSI-CC                                               APKINPTS
015200      THEN                                                        APKINPTS
015300       SET ANSI-TOF TO TRUE                                       APKINPTS
015400      ELSE                                                        APKINPTS
015500       SET MACH-TOF TO TRUE.                                      APKINPTS
015600* The carriage control character is tested for top-of-form.       APKINPTS
015700* This identifies the first line of a page. The line is           APKINPTS
015800* scanned for a space large enough for our text insert.           APKINPTS
015900* The report number and run date are saved for use in the         APKINPTS
016000* indexer key. The page counter is incremented and the            APKINPTS
016100* line counter is reset, then the modified line is passed         APKINPTS
016200* back to ACIF.                                                   APKINPTS
016300* If machine carriage control is used, then the first             APKINPTS
016400* print line is the line after the top-of-form. A flag            APKINPTS
016500* is set to cause this line to be treated as the top.             APKINPTS
016600     IF FIRST-LINE OR (INP-CCVAL = CC-TOF)                        APKINPTS
016700      THEN                                                        APKINPTS
016800       IF ANSI-TOF OR FIRST-LINE                                  APKINPTS
016900        THEN                                                      APKINPTS
017000         ADD 1 TO PAGE-COUNT;                                     APKINPTS
017100         MOVE 1 TO LINE-COUNT;                                    APKINPTS
017200         SET NOTFIRST-LINE TO TRUE;                               APKINPTS
017300        ELSE                                                      APKINPTS
017400         SET FIRST-LINE TO TRUE;                                  APKINPTS
017500       END-IF;                                                    APKINPTS
017600      ELSE                                                        APKINPTS
017700       ADD 1 TO LINE-COUNT;                                       APKINPTS
017800     END-IF.                                                      APKINPTS
017900     SKIP1                                                        APKINPTS
018000* If this record is received from ACIF, send it back and set      APKINPTS
018100* the insert flag and also set our flag to note that a record     APKINPTS
018200* will be inserted on the next call.                              APKINPTS
018300     INSPECT INP-PAGENUM REPLACING ALL SPACES BY ZEROES.          APKINPTS
018400     INSPECT INP-LINENUM REPLACING ALL SPACES BY ZEROES.          APKINPTS
018500     IF INSERT-LINE                                               APKINPTS
018600      THEN                                                        APKINPTS
018700       SET NOINSERT-LINE TO TRUE;                                 APKINPTS
018800       PERFORM 0100-INSERT-RECORD;                                APKINPTS
018900       SET INP-USE TO TRUE;                                       APKINPTS
019000      ELSE                                                        APKINPTS
019100* last line is on page 5, line 5                                  APKINPTS
019200       IF (INP-PAGENUM = 5 AND INP-LINENUM = 5) OR INSERT-MULTIPLEAPKINPTS
019300        THEN                                                      APKINPTS
019400         SET INSERT-MULTIPLE TO TRUE;                             APKINPTS
019500         ADD 1 TO UAREA-INSCOUNT;                                 APKINPTS
019600         IF UAREA-INSCOUNT < 6                                    APKINPTS
019700          THEN                                                    APKINPTS
019800           SET INP-INSERT TO TRUE;                                APKINPTS
019900           PERFORM 0100-INSERT-RECORD;                            APKINPTS
020000          ELSE                                                    APKINPTS
020100           SET INP-DELETE TO TRUE;                                APKINPTS
020200         END-IF;                                                  APKINPTS
020300        ELSE                                                      APKINPTS
020400         SET INSERT-LINE TO TRUE;                                 APKINPTS
020500         SET INP-INSERT TO TRUE;                                  APKINPTS
020600      END-IF;                                                     APKINPTS
020700     END-IF.                                                      APKINPTS
020800     SKIP1                                                        APKINPTS
020900     GOBACK.                                                      APKINPTS
021000 SKIP3                                                            APKINPTS
021100 0100-INSERT-RECORD.                                              APKINPTS
021200* create the record, move it to the provided buffer, and          APKINPTS
021300* set the flag to use the record and then provide a new one.      APKINPTS
021400     MOVE SPACE TO NEW-CC.                                        APKINPTS
021500     ADD 1 TO UAREA-CNTR.                                         APKINPTS
021600     MOVE UAREA-CNTR TO NEW-COUNT.                                APKINPTS
021700     MOVE NEW-LINE TO INP-LINE.                                   APKINPTS
021800     MOVE LENGTH OF NEW-LINE TO INP-RECLEN.                       APKINPTS
