000100 PROCESS DYNAM NUMPROC(PFD) TRUNC(OPT) APOST LIB NOSEQ RES RENT
000200* LAST UPDATE ON 11 May 2000 AT 14:18:45 BY  VEND789 VERSION 01   *
000300 ID DIVISION.
000400 PROGRAM-ID. APKRSLST.
000500 AUTHOR. TURETZKY--HYDRA.
000600 INSTALLATION. IBM BOULDER PROGRAMMING CENTER.
000700               NOTE: REQUIRES VS COBOL II.  This program is an
000800               exit for ACIF (APKACIF,5648-062) that will print a
000900               list of resources referenced in a print job, and
001000               (optionally) cause them to be excluded from the
001100               output resource library.
001200
001300               In order to use this exit, you must use the ACIF
001400               control statement RESTYPE=ALL for the list to be
001500               complete. RESTYPE=NONE will produce no list at all.
001600               If you only wish to see certain type of resource,
001700               use RESTYPE to select it. Include the control
001800               RESEXIT=APKRSLST to enable this exit, and include
001900               the load module in a dataset referenced in STEPLIB
002000               or elsewhere in the module search order.
002100
002200               To control resource inclusion in the output
002300               resource library, set the value of RES-ACTION
002400               appropriately.  Note that if resources are
002500               excluded, resources contained in overlays will not
002600               appear in the report because overlay contents will
002700               not be processed by ACIF.
002800
002900               Method of operation: each resource name is saved in
003000               a table for that type of resource. The table may be
003100               searched to eliminate duplicates. When the last
003200               call flag is set, the contents of the tables are
003300               printed.
003400
003500               You must allocate a DD named PAPKRSLS for the print
003600               file, with an LRECL of 84, BLKSIZE of n*84+4, VBA.
003700
003800               This program must either be compiled with the
003900               NORENT option or linked with IGZOPT with the
004000               RTEREUS option.  (See VS COBOL II Application
004100               Programming Guide, SC26-4045).
004200
004300*/**************************************************************/
004400*/ 970421 (HLT) RAISED OVERLAY AND PSEG TABLE SIZES DUE TO     */
004500*/              NEW UPPER LIMIT IN PSF (PSF IS ABOUT 32K)  01A */
004600*/ 000511 (HLT) ADDED NEW OBJECT TYPES                     02A */
004700*/**************************************************************/
004800 DATE-WRITTEN. 23 FEB 93.
004900 DATE-COMPILED.
005000 SECURITY. IBM SAMPLE CODE ONLY.
005100*/**************************************************************/
005200*/*   (C) COPYRIGHT IBM CORPORATION, 1991                      */
005300*/*                                                            */
005400*/*        >>>>>>>  IMPORTANT NOTICE   <<<<<<<<<<<             */
005500*/*                                                            */
005600*/*   THIS PROGRAM IS NOT SUPPORTED IN ANY WAY BY IBM.  IT     */
005700*/*   HAS NOT BEEN SUBJECTED TO ANY FORMAL IBM TESTING AND     */
005800*/*   IS DISTRIBUTED ON AN "AS-IS" BASIS WITHOUT ANY           */
005900*/*   WARRANTY EITHER EXPRESSED OR IMPLIED.  THE USE OF        */
006000*/*   THIS CODE OR ANY INFORMATION OR TECHNIQUES IMPLICIT      */
006100*/*   WITHIN IT IS THE SOLE RESPONSIBILITY OF THE CUSTOMER.    */
006200*/*   SUCH USE DEPENDS UPON THE CUSTOMER'S ABILITY TO          */
006300*/*   EVALUATE THE INFORMATION IN THE CONTEXT OF THEIR OWN     */
006400*/*   PARTICULAR OPERATING ENVIRONMENT.  THIS CODE HAS         */
006500*/*   OPERATED SUCCESSFULLY IN THE COMPUTING ENVIRONMENT AT    */
006600*/*   THE BOULDER PROGRAMMING CENTER.  THERE IS NO             */
006700*/*   GUARANTEE THAT IT WILL OPERATE CORRECTLY ELSEWHERE.      */
006800*/**************************************************************/
006900 TITLE 'ACIF RESOURCE REPORT EXIT'.
007000 ENVIRONMENT DIVISION.
007100 CONFIGURATION SECTION.
007200 SOURCE-COMPUTER. IBM-370.
007300 OBJECT-COMPUTER. IBM-370.
007400 INPUT-OUTPUT SECTION.
007500 FILE-CONTROL.
007600     SELECT PRINT-FILE ASSIGN TO PAPKRSLS.
007700     SKIP2
007800 DATA DIVISION.
007900 FILE SECTION.
008000 FD  PRINT-FILE
008100     BLOCK CONTAINS 0
008200     LABEL RECORDS STANDARD
008300     RECORD VARYING DEPENDING ON PRINT-REC-LEN
008400     RECORDING MODE V.
008500 01  PRINT-RECORD.
008600     05  PRINT-DATA          OCCURS 1 TO 80,
008700                             DEPENDING ON PRINT-REC-LEN,
008800                             PIC X.
008900     EJECT
009000 WORKING-STORAGE SECTION.
009100 77  PGMNAME                 PIC X(8) VALUE 'APKRSLST'.
009200 77  ABND-PGM                PIC X(8) VALUE 'ILBOABN0'.
009300 77  ABEND-CODE              PIC 9(4) BINARY VALUE 12.
009400 77  PRINT-REC-LEN           PIC 9(8) BINARY VALUE ZERO.
009500 77  MIN-REC-LEN             PIC 9(4) BINARY VALUE 9.
009600 77  MAX-REC-LEN             PIC 9(4) BINARY VALUE 81.
009700 77  LINE-COUNT              PIC S9(8) BINARY VALUE ZERO.
009800 77  PAGE-COUNT              PIC S9(8) BINARY VALUE ZERO.
009900 77  PAGE-LEN                PIC S9(8) BINARY VALUE 50.
010000 77  UNKNOWN-CNTR            PIC 9(4) BINARY VALUE ZERO.
010100 77  INCLUDE-RESOURCE        PIC X VALUE X'00'.
010200 77  IGNORE-RESOURCE         PIC X VALUE X'01'.
010300 77  FIRST-TIME-FLAG         PIC X VALUE LOW-VALUE.
010400     88  FIRST-TIME          VALUE HIGH-VALUE.
010500 77  CPAGE                   PIC X VALUE X'41'.
010600 77  CSET                    PIC X VALUE X'40'.
010700 77  CFNT                    PIC X VALUE X'42'.                   !@02A
010800 77  PSEG                    PIC X VALUE X'FB'.
010900 77  OVLY                    PIC X VALUE X'FC'.
011000 77  OBJCON                  PIC X VALUE X'92'.                   !@02A
011100 77  GOCA                    PIC X VALUE X'03'.                   !@02A
011200 77  BCOCA                   PIC X VALUE X'05'.                   !@02A
011300 77  IOCA                    PIC X VALUE X'06'.                   !@02A
011400 77  CPAGE-NAME              PIC X(20) VALUE 'CODE PAGE'.
011500 77  CSET-NAME               PIC X(20) VALUE 'CHARACTER SET'.
011600 77  CFNT-NAME               PIC X(20) VALUE 'CODED FONT'.        !@02A
011700 77  PSEG-NAME               PIC X(20) VALUE 'PAGE SEGMENT'.
011800 77  OVLY-NAME               PIC X(20) VALUE 'OVERLAY'.
011900 77  OBJCON-NAME             PIC X(20) VALUE 'OBJECT CONTAINER'.  !@02A
012000 77  GOCA-NAME               PIC X(20) VALUE 'GOCA OBJECT'.       !@02A
012100 77  BCOCA-NAME              PIC X(20) VALUE 'BCOCA OBJECT'.      !@02A
012200 77  IOCA-NAME               PIC X(20) VALUE 'IOCA OBJECT.'.      !@02A
012300     SKIP2
012400* code page name table
012500 01  CPGS-USED.
012600     05  CPGS-CNTR           PIC 9(4) BINARY VALUE ZERO.
012700     05  CPGS-TABLE          OCCURS 256
012800                             DEPENDING ON CPGS-CNTR
012900                             INDEXED BY CPGS-INDEX
013000                             PIC X(8).
013100* character sets used table
013200 01  CSETS-USED.
013300     05  CSETS-CNTR          PIC 9(4) BINARY VALUE ZERO.
013400     05  CSETS-TABLE         OCCURS 256
013500                             DEPENDING ON CSETS-CNTR
013600                             INDEXED BY CSETS-INDEX
013700                             PIC X(8).
013800* coded fonts used table                                          !@02a
013900 01  CFNTS-USED.
014000     05  CFNTS-CNTR          PIC 9(4) BINARY VALUE ZERO.
014100     05  CFNTS-TABLE         OCCURS 256
014200                             DEPENDING ON CFNTS-CNTR
014300                             INDEXED BY CFNTS-INDEX
014400                             PIC X(8).
014500* page segments used table
014600 01  PSEGS-USED.
014700     05  PSEGS-CNTR          PIC 9(4) BINARY VALUE ZERO.
014800     05  PSEGS-TABLE         OCCURS 2048                           @02A
014900                             DEPENDING ON PSEGS-CNTR
015000                             INDEXED BY PSEGS-INDEX
015100                             PIC X(8).
015200* overlays used table
015300 01  OVLYS-USED.
015400     05  OVLYS-CNTR          PIC 9(4) BINARY VALUE ZERO.
015500     05  OVLYS-TABLE         OCCURS 1024                           @01A
015600                             DEPENDING ON OVLYS-CNTR
015700                             INDEXED BY OVLYS-INDEX
015800                             PIC X(8).
015900* object containers used table.                                   !@02a
016000 01  OBJCON-USED.
016100     05  OBJCON-CNTR         PIC 9(4) BINARY VALUE ZERO.
016200     05  OBJCON-TABLE        OCCURS 2048                           @01A
016300                             DEPENDING ON OBJCON-CNTR
016400                             INDEXED BY OBJCON-INDEX
016500                             PIC X(8).
016600* goca objects used table.                                        !@02a
016700 01  GOCA-USED.
016800     05  GOCA-CNTR           PIC 9(4) BINARY VALUE ZERO.
016900     05  GOCA-TABLE          OCCURS 2048                           @01A
017000                             DEPENDING ON GOCA-CNTR
017100                             INDEXED BY GOCA-INDEX
017200                             PIC X(8).
017300* bcoca objects used table.                                        !@02a
017400 01  BCOCA-USED.
017500     05  BCOCA-CNTR          PIC 9(4) BINARY VALUE ZERO.
017600     05  BCOCA-TABLE         OCCURS 2048                           @01A
017700                             DEPENDING ON BCOCA-CNTR
017800                             INDEXED BY BCOCA-INDEX
017900                             PIC X(8).
018000* ioca objects used table.                                        !@02a
018100 01  IOCA-USED.
018200     05  IOCA-CNTR           PIC 9(4) BINARY VALUE ZERO.
018300     05  IOCA-TABLE          OCCURS 2048                           @01A
018400                             DEPENDING ON IOCA-CNTR
018500                             INDEXED BY IOCA-INDEX
018600                             PIC X(8).
018700     SKIP2
018800 01  PAGE-TITLE.
018900     05  FILLER              PIC X VALUE '1'.
019000     05  FILLER              PIC X(10) VALUE SPACES.
019100     05  FILLER              PIC X(26)
019200                             VALUE 'ACIF Resources Used Report'.
019300     05  FILLER              PIC X(4)  VALUE SPACES.
019400     05  PAGE-TIMESTAMP      PIC X(10).
019500     05  FILLER              PIC X     VALUE SPACE.
019600     05  FILLER              PIC X(05) VALUE 'Page'.
019700     05  LINE-PAGE-NUM       PIC Z(4).
019800         SKIP1
019900 01  PAGE-SUBTITLE-1.
020000     05  FILLER              PIC X VALUE SPACE.
020100     05  FILLER              PIC X(10) VALUE SPACES.
020200     05  FILLER              PIC XXX VALUE 'CC'.
020300     05  FILLER              PIC X VALUE SPACE.
020400     05  FILLER              PIC X(7) VALUE 'CC Type'.
020500     05  FILLER              PIC X VALUE SPACE.
020600     05  FILLER              PIC X(20) VALUE 'CHARS'.
020700     05  FILLER              PIC X VALUE SPACE.
020800     05  FILLER              PIC X(8) VALUE 'FORMDEF'.
020900     05  FILLER              PIC X VALUE SPACE.
021000     05  FILLER              PIC X(8) VALUE 'PAGEDEF'.
021100     05  FILLER              PIC X VALUE SPACE.
021200     05  FILLER              PIC X(8) VALUE 'PRMODE'.
021300     05  FILLER              PIC X VALUE SPACE.
021400     05  FILLER              PIC XXX VALUE 'TRC'.
021500         SKIP1
021600 01  PAGE-SUBTITLE-2.
021700     05  FILLER              PIC X VALUE SPACE.
021800     05  FILLER              PIC X(10) VALUE SPACES.
021900     05  PS1-CC              PIC XXX.
022000     05  FILLER              PIC X VALUE SPACE.
022100     05  PS1-CCTYPE          PIC X.
022200     05  FILLER              PIC X(7) VALUE SPACE.
022300     05  PS1-CHARS           PIC X(20).
022400     05  FILLER              PIC X VALUE SPACE.
022500     05  PS1-FORMDEF         PIC X(8).
022600     05  FILLER              PIC X VALUE SPACE.
022700     05  PS1-PAGEDEF         PIC X(8).
022800     05  FILLER              PIC X VALUE SPACE.
022900     05  PS1-PRMODE          PIC X(8).
023000     05  FILLER              PIC X VALUE SPACE.
023100     05  PS1-TRC             PIC XXX.
023200         SKIP1
023300 01  PAGE-SUBTITLE-3.
023400     05  FILLER              PIC X VALUE '0'.
023500     05  FILLER              PIC X(10) VALUE SPACES.
023600     05  FILLER              PIC X(14)
023700                             VALUE 'Resource Name '.
023800     05  PS-RESTYPE          PIC X(20).
023900         SKIP1
024000 01  LINE-DETAIL.
024100     05  LINE-CC             PIC X   VALUE SPACE.
024200     05  FILLER              PIC X(02) VALUE SPACES.
024300     05  LINE-RESNAME        PIC X(8).
024400         SKIP1
024500 01  TIME-STAMP.
024600     05  T-S-DAY             PIC 9(5).
024700     05  FILLER              PIC X VALUE '/'.
024800     05  T-S-TIME            PIC X(6).
024900         SKIP1
025000/ PASSED PARAMETERS.
025100 LINKAGE SECTION.
025200 01  RES-PARMS.
025300     05  RES-USTOR           POINTER.
025400     05  RES-PFATTR          POINTER.
025500     05  RES-RSNAME          PIC X(8).
025600     05  RES-RSTYPE          PIC X.
025700     05  RES-ACTION          PIC X.
025800     05  RES-EOF-FLAG        PIC X.
025900         88  RES-EOF         VALUE 'Y'.
026000
026100 01  RES-UAREA               PIC X(16).
026200
026300 01  RES-ATTR.
026400     05  RES-CC              PIC XXX.
026500     05  RES-CCTYPE          PIC X.
026600     05  RES-CHARS           PIC X(20).
026700     05  RES-FORMDEF         PIC X(8).
026800     05  RES-PAGEDEF         PIC X(8).
026900     05  RES-PRMODE          PIC X(8).
027000     05  RES-TRC             PIC XXX.
027100 TITLE 'INITIALIZATION AND MAIN LINE'.
027200 PROCEDURE DIVISION USING RES-PARMS.
027300 0010-UPDATE-TABLE.
027400     SET ADDRESS OF RES-UAREA TO RES-USTOR.
027500     IF RES-EOF
027600      THEN
027700       PERFORM 0100-PRINT-REPORT;
027800       GOBACK;
027900     END-IF.
028000     EVALUATE RES-RSTYPE
028100* ACIF presents code pages each time they appear in a font, so
028200* there may be many occurences of the same codepage. Make sure
028300* we save only 1 of each.
028400      WHEN CPAGE
028500       SET CPGS-INDEX TO 1;
028600       SEARCH CPGS-TABLE
028700        AT END
028800         ADD 1 TO CPGS-CNTR;
028900         MOVE RES-RSNAME TO CPGS-TABLE (CPGS-INDEX);
029000        WHEN RES-RSNAME = CPGS-TABLE (CPGS-INDEX)
029100         CONTINUE;
029200       END-SEARCH;
029300      WHEN CSET
029400       ADD 1 TO CSETS-CNTR;
029500       SET CSETS-INDEX TO CSETS-CNTR;
029600       MOVE RES-RSNAME TO CSETS-TABLE (CSETS-INDEX);
029700      WHEN CFNT
029800       ADD 1 TO CFNTS-CNTR;
029900       SET CFNTS-INDEX TO CFNTS-CNTR;
030000       MOVE RES-RSNAME TO CFNTS-TABLE (CFNTS-INDEX);
030100      WHEN PSEG
030200       ADD 1 TO PSEGS-CNTR;
030300       SET PSEGS-INDEX TO PSEGS-CNTR;
030400       MOVE RES-RSNAME TO PSEGS-TABLE (PSEGS-INDEX);
030500      WHEN OVLY
030600       ADD 1 TO OVLYS-CNTR;
030700       SET OVLYS-INDEX TO OVLYS-CNTR;
030800       MOVE RES-RSNAME TO OVLYS-TABLE (OVLYS-INDEX);
030900      WHEN OBJCON
031000       ADD 1 TO OBJCON-CNTR;
031100       SET OBJCON-INDEX TO OBJCON-CNTR;
031200       MOVE RES-RSNAME TO OBJCON-TABLE (OBJCON-INDEX);
031300      WHEN GOCA
031400       ADD 1 TO GOCA-CNTR;
031500       SET GOCA-INDEX TO GOCA-CNTR;
031600       MOVE RES-RSNAME TO GOCA-TABLE (GOCA-INDEX);
031700      WHEN BCOCA
031800       ADD 1 TO BCOCA-CNTR;
031900       SET BCOCA-INDEX TO BCOCA-CNTR;
032000       MOVE RES-RSNAME TO BCOCA-TABLE (BCOCA-INDEX);
032100      WHEN IOCA
032200       ADD 1 TO IOCA-CNTR;
032300       SET IOCA-INDEX TO IOCA-CNTR;
032400       MOVE RES-RSNAME TO IOCA-TABLE (IOCA-INDEX);
032500      WHEN OTHER
032600       ADD 1 TO UNKNOWN-CNTR;
032700     END-EVALUATE.
032800* The following omits or includes all resources.
032900*    MOVE IGNORE-RESOURCE TO RES-ACTION.
033000     MOVE INCLUDE-RESOURCE TO RES-ACTION.
033100     GOBACK.
033200 TITLE 'Produce Resource Used Report'.
033300 0100-PRINT-REPORT.
033400     ACCEPT T-S-DAY FROM DAY.
033500     ACCEPT T-S-TIME FROM TIME.
033600     MOVE TIME-STAMP TO PAGE-TIMESTAMP.
033700     SET ADDRESS OF RES-ATTR TO RES-PFATTR.
033800     MOVE RES-CC TO PS1-CC.
033900     MOVE RES-CCTYPE TO PS1-CCTYPE.
034000     MOVE RES-CHARS TO PS1-CHARS.
034100     MOVE RES-FORMDEF TO PS1-FORMDEF.
034200     MOVE RES-PAGEDEF TO PS1-PAGEDEF.
034300     MOVE RES-PRMODE TO PS1-PRMODE.
034400     MOVE RES-TRC TO PS1-TRC.
034500     SKIP1
034600     OPEN OUTPUT PRINT-FILE.
034700     SKIP1
034800     MOVE CFNT-NAME TO PS-RESTYPE.                                !@02A
034900     MOVE PAGE-LEN TO LINE-COUNT.
035000     PERFORM WITH TEST BEFORE
035100         VARYING CFNTS-INDEX FROM 1 BY 1
035200         UNTIL CFNTS-INDEX > CFNTS-CNTR;
035300       MOVE CFNTS-TABLE (CFNTS-INDEX) TO LINE-RESNAME;
035400       PERFORM 0120-PRINT-DETAIL;
035500     END-PERFORM.
035600     MOVE CPAGE-NAME TO PS-RESTYPE.
035700     MOVE PAGE-LEN TO LINE-COUNT.
035800     PERFORM WITH TEST BEFORE
035900         VARYING CPGS-INDEX FROM 1 BY 1
036000         UNTIL CPGS-INDEX > CPGS-CNTR;
036100       MOVE CPGS-TABLE (CPGS-INDEX) TO LINE-RESNAME;
036200       PERFORM 0120-PRINT-DETAIL;
036300     END-PERFORM.
036400     MOVE CSET-NAME TO PS-RESTYPE.
036500     MOVE PAGE-LEN TO LINE-COUNT.
036600     PERFORM WITH TEST BEFORE
036700         VARYING CSETS-INDEX FROM 1 BY 1
036800         UNTIL CSETS-INDEX > CSETS-CNTR;
036900       MOVE CSETS-TABLE (CSETS-INDEX) TO LINE-RESNAME;
037000       PERFORM 0120-PRINT-DETAIL;
037100     END-PERFORM.
037200* page segments
037300     MOVE PSEG-NAME TO PS-RESTYPE.
037400     MOVE PAGE-LEN TO LINE-COUNT.
037500     PERFORM WITH TEST BEFORE
037600       VARYING PSEGS-INDEX FROM 1 BY 1
037700       UNTIL PSEGS-INDEX > PSEGS-CNTR;
037800       MOVE PSEGS-TABLE (PSEGS-INDEX) TO LINE-RESNAME;
037900       PERFORM 0120-PRINT-DETAIL;
038000     END-PERFORM.
038100* overlays
038200     MOVE OVLY-NAME TO PS-RESTYPE.
038300     MOVE PAGE-LEN TO LINE-COUNT.
038400     PERFORM WITH TEST BEFORE
038500         VARYING OVLYS-INDEX FROM 1 BY 1
038600         UNTIL OVLYS-INDEX > OVLYS-CNTR;
038700       MOVE OVLYS-TABLE (OVLYS-INDEX) TO LINE-RESNAME;
038800       PERFORM 0120-PRINT-DETAIL;
038900     END-PERFORM.
039000* object containers                                               !@02a
039100     MOVE OBJCON-NAME TO PS-RESTYPE.
039200     MOVE PAGE-LEN TO LINE-COUNT.
039300     PERFORM WITH TEST BEFORE
039400         VARYING OBJCON-INDEX FROM 1 BY 1
039500         UNTIL OBJCON-INDEX > OBJCON-CNTR;
039600       MOVE OBJCON-TABLE (OBJCON-INDEX) TO LINE-RESNAME;
039700       PERFORM 0120-PRINT-DETAIL;
039800     END-PERFORM.
039900* goca objects                                                    !@02a
040000     MOVE GOCA-NAME TO PS-RESTYPE.
040100     MOVE PAGE-LEN TO LINE-COUNT.
040200     PERFORM WITH TEST BEFORE
040300         VARYING GOCA-INDEX FROM 1 BY 1
040400         UNTIL GOCA-INDEX > GOCA-CNTR;
040500       MOVE GOCA-TABLE (GOCA-INDEX) TO LINE-RESNAME;
040600       PERFORM 0120-PRINT-DETAIL;
040700     END-PERFORM.
040800* bcoca objects                                                   !@02a
040900     MOVE BCOCA-NAME TO PS-RESTYPE.
041000     MOVE PAGE-LEN TO LINE-COUNT.
041100     PERFORM WITH TEST BEFORE
041200         VARYING BCOCA-INDEX FROM 1 BY 1
041300         UNTIL BCOCA-INDEX > BCOCA-CNTR;
041400       MOVE BCOCA-TABLE (BCOCA-INDEX) TO LINE-RESNAME;
041500       PERFORM 0120-PRINT-DETAIL;
041600     END-PERFORM.
041700* ioca objects                                                    !@02a
041800     MOVE IOCA-NAME TO PS-RESTYPE.
041900     MOVE PAGE-LEN TO LINE-COUNT.
042000     PERFORM WITH TEST BEFORE
042100         VARYING IOCA-INDEX FROM 1 BY 1
042200         UNTIL IOCA-INDEX > IOCA-CNTR;
042300       MOVE IOCA-TABLE (IOCA-INDEX) TO LINE-RESNAME;
042400       PERFORM 0120-PRINT-DETAIL;
042500     END-PERFORM.
042600     SKIP1
042700     CLOSE PRINT-FILE.
042800     SKIP1
042900       SKIP2
043000 0110-PRINT-HEADER.
043100     ADD 1 TO PAGE-COUNT.
043200     MOVE PAGE-COUNT TO LINE-PAGE-NUM.
043300     MOVE LENGTH OF PAGE-TITLE TO PRINT-REC-LEN.
043400     WRITE PRINT-RECORD FROM PAGE-TITLE.
043500     MOVE LENGTH OF PAGE-SUBTITLE-1 TO PRINT-REC-LEN.
043600     WRITE PRINT-RECORD FROM PAGE-SUBTITLE-1.
043700     MOVE LENGTH OF PAGE-SUBTITLE-2 TO PRINT-REC-LEN.
043800     WRITE PRINT-RECORD FROM PAGE-SUBTITLE-2.
043900     MOVE LENGTH OF PAGE-SUBTITLE-3 TO PRINT-REC-LEN.
044000     WRITE PRINT-RECORD FROM PAGE-SUBTITLE-3.
044100     MOVE ZERO TO LINE-COUNT.
044200       SKIP2
044300 0120-PRINT-DETAIL.
044400     IF LINE-COUNT >= PAGE-LEN
044500      THEN
044600       PERFORM 0110-PRINT-HEADER;
044700     END-IF.
044800     ADD 1 TO LINE-COUNT.
044900     MOVE LENGTH OF LINE-DETAIL TO PRINT-REC-LEN.
045000     WRITE PRINT-RECORD FROM LINE-DETAIL.
