000100 PROCESS NOD NUMPROC(PFD) TRUNC(OPT) APOST LIB NOSEQ RES RENT     APKBTINP
000200* LAST UPDATE ON 14 Oct 1994 AT 07:25:00 BY  VEND789 VERSION 01   APKBTINP
000300 ID DIVISION.                                                     APKBTINP
000400 PROGRAM-ID. APKBTINP.                                            APKBTINP
000500 AUTHOR. TURETZKY--HYDRA.                                         APKBTINP
000600 INSTALLATION. IBM BOULDER PROGRAMMING CENTER.                    APKBTINP
000700               NOTE: REQUIRES VS COBOL II.  This program is a     APKBTINP
000800               sample exit for ACIF (APKACIF,5648-062)            APKBTINP
000900               demonstrating the use of the ACIF input exit.      APKBTINP
001000                                                                  APKBTINP
001100               In order to use this exit, include the control     APKBTINP
001200               INPEXIT=APKBTINP to enable this exit, and include  APKBTINP
001300               the load module in a dataset referenced in steplib APKBTINP
001400               or elsewhere in the module search order.           APKBTINP
001500                                                                  APKBTINP
001600               This program will change input lines with the      APKBTINP
001700               carriage control character 'Z' (used for report    APKBTINP
001800               distriubtion exits) into an AFPDS NOP. It also     APKBTINP
001900               switches the order of the 'Z' record with the      APKBTINP
002000               following skip to channel 1 record, so the order   APKBTINP
002100               becomes skip to channel 1, then 'Z' record. This   APKBTINP
002200               is to make ACIF index properly when only a single  APKBTINP
002300               page appears in the group. Normally, ACIF would    APKBTINP
002400               associate the 'Z' record with the previous page    APKBTINP
002410               which actually contains it.                        APKBTINP
002500                                                                  APKBTINP
002600               Method of operation: each input record is examined APKBTINP
002700               for the carriage control character. If it is 'Z',  APKBTINP
002800               then the reocrd is changed to a NOP and saved in a APKBTINP
002900               buffer.  If it is skip to channel 1, then the      APKBTINP
003000               record is returned to ACIF with the insert         APKBTINP
003100               indicator set, and the 'Z' record inserted on the  APKBTINP
003110               next call.                                         APKBTINP
003200                                                                  APKBTINP
003300               This program must either be compiled with the      APKBTINP
003400               NORENT option or linked with IGZOPT with the       APKBTINP
003500               RTEREUS option.  (See VS COBOL II Application      APKBTINP
003600               Programming Guide, SC26-4045).                     APKBTINP
003700                                                                  APKBTINP
003800 DATE-WRITTEN. 14 Jul 94.                                         APKBTINP
003900 DATE-COMPILED.                                                   APKBTINP
004000 SECURITY. IBM SAMPLE CODE ONLY.                                  APKBTINP
004100*/**************************************************************/ APKBTINP
004200*/*   (C) COPYRIGHT IBM CORPORATION, 1993                      */ APKBTINP
004300*/*                                                            */ APKBTINP
004400*/*        >>>>>>>  IMPORTANT NOTICE   <<<<<<<<<<<             */ APKBTINP
004500*/*                                                            */ APKBTINP
004600*/*   THIS PROGRAM IS NOT SUPPORTED IN ANY WAY BY IBM.  IT     */ APKBTINP
004700*/*   HAS NOT BEEN SUBJECTED TO ANY FORMAL IBM TESTING AND     */ APKBTINP
004800*/*   IS DISTRIBUTED ON AN "AS-IS" BASIS WITHOUT ANY           */ APKBTINP
004900*/*   WARRANTY EITHER EXPRESSED OR IMPLIED.  THE USE OF        */ APKBTINP
005000*/*   THIS CODE OR ANY INFORMATION OR TECHNIQUES IMPLICIT      */ APKBTINP
005100*/*   WITHIN IT IS THE SOLE RESPONSIBILITY OF THE CUSTOMER.    */ APKBTINP
005200*/*   SUCH USE DEPENDS UPON THE CUSTOMER'S ABILITY TO          */ APKBTINP
005300*/*   EVALUATE THE INFORMATION IN THE CONTEXT OF THEIR OWN     */ APKBTINP
005400*/*   PARTICULAR OPERATING ENVIRONMENT.  THIS CODE HAS         */ APKBTINP
005500*/*   OPERATED SUCCESSFULLY IN THE COMPUTING ENVIRONMENT AT    */ APKBTINP
005600*/*   THE BOULDER PROGRAMMING CENTER.  THERE IS NO             */ APKBTINP
005700*/*   GUARANTEE THAT IT WILL OPERATE CORRECTLY ELSEWHERE.      */ APKBTINP
005800*/**************************************************************/ APKBTINP
005900 TITLE 'ACIF INPUT EXIT--FILTER LLE RECORDS'.                     APKBTINP
006000 ENVIRONMENT DIVISION.                                            APKBTINP
006100 CONFIGURATION SECTION.                                           APKBTINP
006200 SOURCE-COMPUTER. IBM-370.                                        APKBTINP
006300 OBJECT-COMPUTER. IBM-370.                                        APKBTINP
006400     EJECT                                                        APKBTINP
006500 DATA DIVISION.                                                   APKBTINP
006600 WORKING-STORAGE SECTION.                                         APKBTINP
006700 77  PGMNAME                 PIC X(8) VALUE 'APKBTINP'.           APKBTINP
006800 77  ABND-PGM                PIC X(8) VALUE 'ILBOABN0'.           APKBTINP
006900 77  ABEND-CODE              PIC 9(4) BINARY VALUE 12.            APKBTINP
007000 77  LINE-COUNT              PIC S9(8) BINARY VALUE ZERO.         APKBTINP
007100 77  PAGE-COUNT              PIC S9(8) BINARY VALUE ZERO.         APKBTINP
007200 77  PAGE-DISP               PIC Z,ZZZ,ZZ9.                       APKBTINP
007300 77  CC-SF                   PIC X VALUE X'5A'.                   APKBTINP
007400 77  CC-DIST                 PIC X VALUE 'Z'.                     APKBTINP
007500 77  CC-TOF                  PIC X.                               APKBTINP
007600     88  ANSI-TOF            VALUE '1'.                           APKBTINP
007700     88  MACH-TOF            VALUE X'8B'.                         APKBTINP
007800 77  FIRST-LINE-FLAG         PIC X VALUE LOW-VALUE.               APKBTINP
007900     88  FIRST-LINE          VALUE HIGH-VALUE.                    APKBTINP
008000     88  NOTFIRST-LINE       VALUE LOW-VALUE.                     APKBTINP
008100     SKIP1                                                        APKBTINP
008200/ AFP STRUCTURED FIELD DEFINITIONS.                               APKBTINP
008300     COPY STRFLDS SUPPRESS.                                       APKBTINP
008400     EJECT                                                        APKBTINP
008500 01  ZREC-BUFFER             PIC X(068).                          APKBTINP
008600/ PASSED PARAMETERS.                                              APKBTINP
008700 LINKAGE SECTION.                                                 APKBTINP
008800 01  INP-PARMS.                                                   APKBTINP
008900     05  INP-USTOR           POINTER.                             APKBTINP
009000     05  INP-PFATTR          POINTER.                             APKBTINP
009100     05  INP-RECPTR          POINTER.                             APKBTINP
009200     05  FILLER              POINTER.                             APKBTINP
009300     05  INP-RECLEN          PIC 9(4) BINARY.                     APKBTINP
009400     05  FILLER              PIC XX.                              APKBTINP
009500     05  INP-REQUEST         PIC X.                               APKBTINP
009600         88  INP-USE         VALUE X'00'.                         APKBTINP
009700         88  INP-DELETE      VALUE X'01'.                         APKBTINP
009800         88  INP-INSERT      VALUE X'02'.                         APKBTINP
009900     05  INP-EOF-FLAG        PIC X.                               APKBTINP
010000         88  INP-EOF         VALUE 'Y'.                           APKBTINP
010100     SKIP1                                                        APKBTINP
010200 01  INP-UAREA.                                                   APKBTINP
010300     05  INSERT-FLAG         PIC X.                               APKBTINP
010400         88 INSERT-LINE      VALUE HIGH-VALUE.                    APKBTINP
010500         88 INSERT-MULTIPLE  VALUE 'M'.                           APKBTINP
010600         88 NOINSERT-LINE    VALUE LOW-VALUE.                     APKBTINP
010700     05  FILLER              PIC X(15).                           APKBTINP
010800     SKIP1                                                        APKBTINP
010900 01  INP-ATTR.                                                    APKBTINP
011000     05  INP-CC              PIC XXX.                             APKBTINP
011100     05  INP-CCTYPE          PIC X.                               APKBTINP
011200         88  INP-ANSI-CC     VALUE 'A'.                           APKBTINP
011300         88  INP-MACH-CC     VALUE 'M'.                           APKBTINP
011400     05  INP-CHARS           PIC X(20).                           APKBTINP
011500     05  INP-FORMDEF         PIC X(8).                            APKBTINP
011600     05  INP-PAGEDEF         PIC X(8).                            APKBTINP
011700     05  INP-PRMODE          PIC X(8).                            APKBTINP
011800     05  INP-TRC             PIC XXX.                             APKBTINP
011900     SKIP1                                                        APKBTINP
012000* This is a template for the input record, pointed to by          APKBTINP
012100* INP-RECPTR. The record's actual length is given by              APKBTINP
012200* INP-RECLEN.                                                     APKBTINP
012300 01  INP-REC.                                                     APKBTINP
012400     05  INP-CCVAL           PIC X.                               APKBTINP
012500     05  INP-SFHDR.                                               APKBTINP
012600         10 INP-LEN          PIC 9(4) BINARY.                     APKBTINP
012700         10 INP-SFID         PIC X(3).                            APKBTINP
012800         10 INP-FLAGSEQ.                                          APKBTINP
012900             15 INP-FLAG     PIC X.                               APKBTINP
013000             15 INP-SEQ      PIC 9(4) BINARY.                     APKBTINP
013100     05  INP-DATA            PIC X(32747).                        APKBTINP
013200     SKIP1                                                        APKBTINP
013300 TITLE 'Initialization and Main Line'.                            APKBTINP
013400 PROCEDURE DIVISION USING INP-PARMS.                              APKBTINP
013500* make work area, attributes, and input line addressable.         APKBTINP
013600     SET ADDRESS OF INP-UAREA TO INP-USTOR.                       APKBTINP
013700     SET ADDRESS OF INP-ATTR TO INP-PFATTR.                       APKBTINP
013800     SET ADDRESS OF INP-REC TO INP-RECPTR.                        APKBTINP
013900* No special action is necessary at EOF.                          APKBTINP
014000     IF INP-EOF                                                   APKBTINP
014100      THEN                                                        APKBTINP
014200       DISPLAY PGMNAME, ' EOF REACHED.';                          APKBTINP
014300       MOVE PAGE-COUNT TO PAGE-DISP;                              APKBTINP
014400       DISPLAY PGMNAME, PAGE-DISP, ' Pages processed.';           APKBTINP
014500       GOBACK;                                                    APKBTINP
014600     END-IF.                                                      APKBTINP
014700* The print file attributes are used to determine the type        APKBTINP
014800* of carriage control to test for for top-of-form.                APKBTINP
014900* For purposes of this example, we assume the file will           APKBTINP
015000* always have carriage control, and if machine control the        APKBTINP
015100* skip to channel 1 immediate is used for new pages.              APKBTINP
015200     IF INP-ANSI-CC                                               APKBTINP
015300      THEN                                                        APKBTINP
015400       SET ANSI-TOF TO TRUE                                       APKBTINP
015500      ELSE                                                        APKBTINP
015600       SET MACH-TOF TO TRUE.                                      APKBTINP
015700     IF INSERT-LINE                                               APKBTINP
015800      THEN                                                        APKBTINP
015900* Send the saved record back to acif.                             APKBTINP
016000       SET NOINSERT-LINE TO TRUE;                                 APKBTINP
016100       MOVE ZREC-BUFFER TO INP-REC;                               APKBTINP
016200       ADD INP-LEN, 1 GIVING INP-RECLEN;                          APKBTINP
016300       SET INP-USE TO TRUE;                                       APKBTINP
016400      ELSE                                                        APKBTINP
016500       EVALUATE INP-CCVAL                                         APKBTINP
016600        WHEN CC-TOF                                               APKBTINP
016700*   Pass the record back and signal an inserted record            APKBTINP
016800         ADD 1 TO PAGE-COUNT;                                     APKBTINP
016900         MOVE ZERO TO LINE-COUNT;                                 APKBTINP
017000         SET INP-INSERT TO TRUE;                                  APKBTINP
017100         SET INSERT-LINE TO TRUE;                                 APKBTINP
017200        WHEN CC-DIST                                              APKBTINP
017300*   Construct the NOP and save it in the ZREC buffer, then tell   APKBTINP
017400*   ACIF to delete it.                                            APKBTINP
017500         MOVE INP-REC TO ZREC-BUFFER;                             APKBTINP
017600         MOVE CC-SF TO INP-CCVAL;                                 APKBTINP
017700         MOVE SF-NOP TO INP-SFID;                                 APKBTINP
017800         MOVE LOW-VALUE TO INP-FLAG;                              APKBTINP
017900         MOVE PAGE-COUNT TO INP-SEQ;                              APKBTINP
018000         ADD INP-RECLEN, LENGTH OF INP-SFHDR GIVING INP-LEN;      APKBTINP
018100         MOVE ZREC-BUFFER TO INP-DATA;                            APKBTINP
018200         ADD 1 TO LINE-COUNT;                                     APKBTINP
018300         MOVE INP-REC TO ZREC-BUFFER;                             APKBTINP
018400         SET INP-DELETE TO TRUE;                                  APKBTINP
018500        WHEN OTHER                                                APKBTINP
018600         ADD 1 TO LINE-COUNT;                                     APKBTINP
018700       END-EVALUATE;                                              APKBTINP
018800     END-IF.                                                      APKBTINP
018900     GOBACK.                                                      APKBTINP
019000 SKIP1                                                            APKBTINP
019100 END PROGRAM APKBTINP.                                            APKBTINP
